searchNodes=[{"doc":"Execute edeliver tasks on the production / staging nodes. This internal module provides functions on the nodes which are used by some edeliver tasks e.g. to get the running release version ( edeliver version ), show the pending migrations ( edeliver show migrations ) or install pending migrations ( edeliver migrate ). In addition it represents the edeliver application callback module and starts a process registered locally as Edeliver which's onliest purpose is to be able to detect whether the release was successfully started. This requires to start edeliver as last application in the release.","ref":"Edeliver.html","title":"Edeliver","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Edeliver.html#child_spec/1","title":"Edeliver.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Edeliver.html#init/1","title":"Edeliver.init/1","type":"function"},{"doc":"Prints the pending ecto migrations","ref":"Edeliver.html#list_pending_migrations/3","title":"Edeliver.list_pending_migrations/3","type":"function"},{"doc":"Runs the pending ecto migrations","ref":"Edeliver.html#migrate/5","title":"Edeliver.migrate/5","type":"function"},{"doc":"Returns the current directory containing the ecto migrations.","ref":"Edeliver.html#migrations_dir/2","title":"Edeliver.migrations_dir/2","type":"function"},{"doc":"Waits until the edeliver application is started. If the edeliver application is added as last application in the :applications section of the application/0 fun in the mix.exs this waits until all applications are started. This can be used as rpc call after running the asynchronous bin/$APP start command to wait until all applications started and then return ok .","ref":"Edeliver.html#monitor_startup_progress/1","title":"Edeliver.monitor_startup_progress/1","type":"function"},{"doc":"Returns the running release version which is either the :current version or the :permanent version.","ref":"Edeliver.html#release_version/2","title":"Edeliver.release_version/2","type":"function"},{"doc":"Runs the edeliver command on the erlang node started as: bin / $ APP rpc &#39;Elixir.Edeliver.run_command(&#39; [ command_name , &quot;$APP&quot; , arguments ... ] ) &#39; The first argument must be the name of the command, the second argument the name of the main application and all further arguments are passed to the function that's name is equal to the command name.","ref":"Edeliver.html#run_command/1","title":"Edeliver.run_command/1","type":"function"},{"doc":"Starts the edeliver application including the Edeliver.Supervisor process supervising the Edeliver generic server.","ref":"Edeliver.html#start/2","title":"Edeliver.start/2","type":"function"},{"doc":"Starts this gen-server registered locally as Edeliver","ref":"Edeliver.html#start_link/0","title":"Edeliver.start_link/0","type":"function"},{"doc":"This type represents the current config of the release manager. when using distillery it is a Distillery.Releases.Config.t struct.","ref":"Edeliver.Relup.Config.html","title":"Edeliver.Relup.Config","type":"module"},{"doc":"","ref":"Edeliver.Relup.Config.html#t:t/0","title":"Edeliver.Relup.Config.t/0","type":"type"},{"doc":"This module provides default modifications of the relup instructions. It is used unless a Edeliver.Relup.Modification module is found with a higher priority (and which is also usable) or another module is passed to the --relup-mod= command line option. E.g. for phoenix apps this would be the default Edeliver.Relup.PhoenixModification . This module uses the Edeliver.Relup.Instructions.SoftPurge instruction to replace :brutal_purge code loading options with :soft_purge .","ref":"Edeliver.Relup.DefaultModification.html","title":"Edeliver.Relup.DefaultModification","type":"module"},{"doc":"Callback implementation for Edeliver.Relup.Modification.modify_relup/2 .","ref":"Edeliver.Relup.DefaultModification.html#modify_relup/2","title":"Edeliver.Relup.DefaultModification.modify_relup/2","type":"function"},{"doc":"Returns the priority Edeliver.Relup.Modification.priority_default/0 . Unless the module is set by the RELUP_MODIFICATION_MODULE env or the --relup-mod= command line option the module with the highest priority is used (which is also usable).","ref":"Edeliver.Relup.DefaultModification.html#priority/0","title":"Edeliver.Relup.DefaultModification.priority/0","type":"function"},{"doc":"Returns true if this relup modification is usable for the project or not. E.g. the Edeliver.Relup.PhoenixModifcation returns true only if the project is a phoenix project. This function returns true by default can be overridden in a custom Edeliver.Relup.Modification behaviour implementation.","ref":"Edeliver.Relup.DefaultModification.html#usable?/1","title":"Edeliver.Relup.DefaultModification.usable?/1","type":"function"},{"doc":"Provides functions to insert relup instructions at a given position which can be used in Edeliver.Relup.Instruction behaviour implementations in the relup file.","ref":"Edeliver.Relup.InsertInstruction.html","title":"Edeliver.Relup.InsertInstruction","type":"module"},{"doc":"Appends instruction(s) to the list of other instructions.","ref":"Edeliver.Relup.InsertInstruction.html#append/2","title":"Edeliver.Relup.InsertInstruction.append/2","type":"function"},{"doc":"Appends instruction(s) to the instruction after the &quot;point of no return&quot; but before any instruction which: loads or unloads new code, which means before any load_module , load , add_module , delete_module , remove , purge instruction and before any instruction which updates, starts or stops any running processes, which means before any code_change , update , start , stop instruction and before any instruction which (re-)starts or stops any application or the emulator, which means before any add_application , remove_application , restart_application , restart_emulator and restart_new_emulator instruction. It does not consider load-instructions for Edeliver.Relup.RunnableInstruction s as code loading instructions for the release. They are inserted by the RunnableInstruction itself to ensure that the code of the runnable instruction is loaded before the instruction is executed. See Edeliver.Relup.ShiftInstruction.ensure_module_loaded_before_instruction/3 .","ref":"Edeliver.Relup.InsertInstruction.html#append_after_point_of_no_return/2","title":"Edeliver.Relup.InsertInstruction.append_after_point_of_no_return/2","type":"function"},{"doc":"Inserts instruction(s) after the given instruction.","ref":"Edeliver.Relup.InsertInstruction.html#insert_after_instruction/3","title":"Edeliver.Relup.InsertInstruction.insert_after_instruction/3","type":"function"},{"doc":"Inserts instruction(s) right after the last load_object_code instruction which is usually before the &quot;point of no return&quot; and one of the first instructions. This means that it is the first custom instruction which is executed. It is executed twice, once when checking whether the upgrade can be installed and once when the upgrade is installed.","ref":"Edeliver.Relup.InsertInstruction.html#insert_after_load_object_code/2","title":"Edeliver.Relup.InsertInstruction.insert_after_load_object_code/2","type":"function"},{"doc":"Inserts instruction(s) right after the point of no return. This means that it is the first instruction which should not fail, because the release handler will restart the release if any instruction fails after the point of no return.","ref":"Edeliver.Relup.InsertInstruction.html#insert_after_point_of_no_return/2","title":"Edeliver.Relup.InsertInstruction.insert_after_point_of_no_return/2","type":"function"},{"doc":"Inserts instruction(s) before the given instruction.","ref":"Edeliver.Relup.InsertInstruction.html#insert_before_instruction/3","title":"Edeliver.Relup.InsertInstruction.insert_before_instruction/3","type":"function"},{"doc":"Inserts instruction(s) before the point of no return. All instructions running before that point of no return which fail will cause the upgrade to fail, while failing instructions running after that point will cause the node to restart the release.","ref":"Edeliver.Relup.InsertInstruction.html#insert_before_point_of_no_return/2","title":"Edeliver.Relup.InsertInstruction.insert_before_point_of_no_return/2","type":"function"},{"doc":"Returns true if the given instruction is an instruction which modifies an application by either (re-)starting or stopping it or by restarting the emulator. It returns true for the add_application , remove_application , restart_new_emulator and the restart_emulator , relup instructions.","ref":"Edeliver.Relup.InsertInstruction.html#modifies_applications?/1","title":"Edeliver.Relup.InsertInstruction.modifies_applications?/1","type":"function"},{"doc":"Returns true if the given instruction is an instruction which modifies code by loading, unloading or purging it. It returns true for the load_module , add_module delete_module , load , remove and purge relup instructions.","ref":"Edeliver.Relup.InsertInstruction.html#modifies_code?/1","title":"Edeliver.Relup.InsertInstruction.modifies_code?/1","type":"function"},{"doc":"Returns true if the given instruction is an instruction which modifies any process by either by sending the code_change sys event or by starting or stopping any process. It returns true for the code_change , start , stop and update relup instructions.","ref":"Edeliver.Relup.InsertInstruction.html#modifies_processes?/1","title":"Edeliver.Relup.InsertInstruction.modifies_processes?/1","type":"function"},{"doc":"This behaviour can be used to provide custom instructions to modify the relup. They can be used in the implementations of of the Edeliver.Relup.Modifcation behaviour. Example: defmodule Acme.Relup.LogUpgradeInstruction do use Edeliver.Relup.Instruction def modify_relup ( instructions = % Instructions { up_instructions : up_instructions } , _config = %{ } ) do log_instruction = { :apply , { :&quot;Elixir.Logger&quot; , :info , [ &lt;&lt; &quot;Upgraded successfully&quot; &gt;&gt; ] } } %{ instructions | up_instructions : [ log_instruction | up_instructions ] } end end # using the instruction defmodule Acme.Relup.Modification do use Edeliver.Relup.Modification def modify_relup ( instructions = % Instructions { } , config = %{ } ) do instructions |&gt; Edeliver.Relup.DefaultModification . modify_relup ( config ) # use default modifications |&gt; Acme.Relup.LogUpgradeInstruction . modify_relup ( config ) # apply also custom instructions end end edeliver already provides a set of relup instructions: Edeliver.Relup.Instructions.CheckProcessesRunningOldCode Edeliver.Relup.Instructions.CheckRanchAcceptors Edeliver.Relup.Instructions.CheckRanchConnections Edeliver.Relup.Instructions.CodeChangeOnAppProcesses Edeliver.Relup.Instructions.FinishRunningRequests Edeliver.Relup.Instructions.Info Edeliver.Relup.Instructions.ReloadModules Edeliver.Relup.Instructions.RerunFailedRequests Edeliver.Relup.Instructions.ResumeAppProcesses Edeliver.Relup.Instructions.ResumeChannels Edeliver.Relup.Instructions.ResumeRanchAcceptors Edeliver.Relup.Instructions.Sleep Edeliver.Relup.Instructions.SoftPurge Edeliver.Relup.Instructions.StartSection Edeliver.Relup.Instructions.SuspendAppProcesses Edeliver.Relup.Instructions.SuspendChannels Edeliver.Relup.Instructions.SuspendRanchAcceptors","ref":"Edeliver.Relup.Instruction.html","title":"Edeliver.Relup.Instruction","type":"behaviour"},{"doc":"Modifies the relup file. Modifies the relup file which will be used to upgrade (or downgrade) from one version to another by inserting, removing, or shifting appup instructions . See Edeliver.Relup.InsertInstruction and Edeliver.Relup.ShiftInstruction for useful helpers to insert / position the instructions and Edeliver.Relup.RunnableInstruction to execute custom code during the upgrade.","ref":"Edeliver.Relup.Instruction.html#c:modify_relup/2","title":"Edeliver.Relup.Instruction.modify_relup/2","type":"callback"},{"doc":"A function that inserts a new instruction or a set of new instructions at a given place in the list of existing instructions. For most appup instructions from the relup file it matters when they will be executed, e.g before or after some other instructions.","ref":"Edeliver.Relup.Instruction.html#t:insert_fun/0","title":"Edeliver.Relup.Instruction.insert_fun/0","type":"type"},{"doc":"This struct represents relup instructions from the relup file but in a more accessible way. The up and down instructions can be modified by a Edeliver.Relup.Modification and will be written back to the relup file by edeliver before generating the release tar.","ref":"Edeliver.Relup.Instructions.html","title":"Edeliver.Relup.Instructions","type":"module"},{"doc":"An appup instruction from the relup file","ref":"Edeliver.Relup.Instructions.html#t:instruction/0","title":"Edeliver.Relup.Instructions.instruction/0","type":"type"},{"doc":"A list of appup instructions from the relup file","ref":"Edeliver.Relup.Instructions.html#t:instructions/0","title":"Edeliver.Relup.Instructions.instructions/0","type":"type"},{"doc":"Appup instructions from the relup file which can be modified. They are separated into instructions for the upgrade and instructions for the downgrade and will be later written back to the relup file. changed_modules contains a list of all code modules which changed in the new version and will be loaded during the upgrade.","ref":"Edeliver.Relup.Instructions.html#t:t/0","title":"Edeliver.Relup.Instructions.t/0","type":"type"},{"doc":"Cancels the upgrade if there are processes running old code from previous upgrades. This upgrade instruction checks whether any of the modules that will be (re)loaded during upgrade has old code. If any of them has old code it will throw an error and abort the release upgrade. This prevents crashing and restarting the node during the live upgrade. This instruction is inserted before the &quot;point of no return&quot; which causes it to run twice, once when checking the relup and once when executing the relup.","ref":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.html","title":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode","type":"module"},{"doc":"Returns the modules which will be loaded during the upgrade. These modules are taken as argument for the run/1 function and only these modules are checked whether they run old code. Modules which will not be updated during the upgrade does not affect the upgrade process even if they run old code. The modules to check are take from the load_object_code instructions.","ref":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.html#arguments/2","title":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.arguments/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.html#call_this/1","title":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.call_this/1","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.RunnableInstruction.dependencies/0 .","ref":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.html#dependencies/0","title":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.dependencies/0","type":"function"},{"doc":"Inserts the instruction before the point of no return. This causes the release handler to abort the upgrade already when running :release_handler.check_install_release/1 if this instruction fails.","ref":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.html#insert_where/0","title":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.html#modify_relup/2","title":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.modify_relup/2","type":"function"},{"doc":"Checks whether the modules passed as argument have old code. These modules are the modules which will be upgraded. This function runs twice because it is executed before the &quot;point of no return&quot;, once when checking the relup and once when executing the relup.","ref":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.html#run/1","title":"Edeliver.Relup.Instructions.CheckProcessesRunningOldCode.run/1","type":"function"},{"doc":"This upgrade instruction checks whether the ranch acceptors can be found. This instruction will cause the upgrade to be canceled if the ranch acceptors cannot be found and because it is inserted before the &quot;point of no return&quot; it will run twice, once when checking the relup and once when executing the relup.","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors","type":"module"},{"doc":"Returns the name of the application. This name is taken as argument for the run/1 function and is required to access the acceptor processes through the supervision tree","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html#arguments/2","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors.arguments/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html#call_this/1","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors.call_this/1","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.RunnableInstruction.dependencies/0 .","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html#dependencies/0","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors.dependencies/0","type":"function"},{"doc":"Returns the pid of the phoenix endpoint supervisor or throws and logs an error if it cannot be found. It supervises the Phoenix.Endpoint.Server which supervises the connections and acceptors, Phoenix.Config and the phoenix pubsub supervisor, e.g. Phoenix.PubSub.PG2 .","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html#endpoint/1","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors.endpoint/1","type":"function"},{"doc":"Inserts the instruction before the point of no return. This causes the release handler to abort the upgrade already when running :release_handler.check_install_release/1 if this instruction fails.","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html#insert_where/0","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html#modify_relup/2","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors.modify_relup/2","type":"function"},{"doc":"Gets the supervisor child ids of the ranch socket accecptors ( ranch_acceptor ) from the ranch acceptor supervisor or throws and logs an error if the acceptors cannot be found.","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html#ranch_acceptors/1","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors.ranch_acceptors/1","type":"function"},{"doc":"Gets the pid of the supervisor which supervises the ranch socket acceptors. If it cannot be found as child of the given ranch listener supervisor it throws and logs an error.","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html#ranch_acceptors_sup/1","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors.ranch_acceptors_sup/1","type":"function"},{"doc":"Gets the pid of the ranch listener supervisor ( :ranch_listener_sup ) which supervises the ranch acceptors supervisor ( :ranch_acceptors_sup ) and the connections supervisor ( :ranch_conns_sup ). It throws and logs an error if they cannot be found in the supervison tree of the application.","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html#ranch_listener_sup/1","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors.ranch_listener_sup/1","type":"function"},{"doc":"Checks whether the ranch acceptors can be found. If not the upgrade will be canceled. This function runs twice because it is executed before the &quot;point of no return&quot;, once when checking the relup and once when executing the relup.","ref":"Edeliver.Relup.Instructions.CheckRanchAcceptors.html#run/1","title":"Edeliver.Relup.Instructions.CheckRanchAcceptors.run/1","type":"function"},{"doc":"This upgrade instruction checks whether the running ranch connections can be found. This instruction will cause the upgrade to be canceled if the ranch connections cannot be found and because it is inserted before the &quot;point of no return&quot; it will run twice, once when checking the relup and once when executing the relup. If Phoenix.PubSub.PG2 is used as pubsub backend for phoenix channels, running websocket processes will be detected and suspended by the Edeliver.Relup.Instructions.SuspendChannels instruction during the upgrade and resumed by the Edeliver.Relup.Instructions.ResumeChannels instruction after the upgrade / downgrade of the node.","ref":"Edeliver.Relup.Instructions.CheckRanchConnections.html","title":"Edeliver.Relup.Instructions.CheckRanchConnections","type":"module"},{"doc":"Returns name of the application. This name is taken as argument for the run/1 function and is required to access the acceptor processes through the supervision tree","ref":"Edeliver.Relup.Instructions.CheckRanchConnections.html#arguments/2","title":"Edeliver.Relup.Instructions.CheckRanchConnections.arguments/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.CheckRanchConnections.html#call_this/1","title":"Edeliver.Relup.Instructions.CheckRanchConnections.call_this/1","type":"function"},{"doc":"This module requires the Edeliver.Relup.Instructions.CheckRanchAcceptors module which must be loaded before this instruction for upgrades and unload after this instruction for downgrades.","ref":"Edeliver.Relup.Instructions.CheckRanchConnections.html#dependencies/0","title":"Edeliver.Relup.Instructions.CheckRanchConnections.dependencies/0","type":"function"},{"doc":"Inserts the instruction before the point of no return. This causes the release handler to abort the upgrade already when running :release_handler.check_install_release/1 if this instruction fails.","ref":"Edeliver.Relup.Instructions.CheckRanchConnections.html#insert_where/0","title":"Edeliver.Relup.Instructions.CheckRanchConnections.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.CheckRanchConnections.html#modify_relup/2","title":"Edeliver.Relup.Instructions.CheckRanchConnections.modify_relup/2","type":"function"},{"doc":"Gets the process ids of the ranch socket connections if there are any.","ref":"Edeliver.Relup.Instructions.CheckRanchConnections.html#ranch_connections/1","title":"Edeliver.Relup.Instructions.CheckRanchConnections.ranch_connections/1","type":"function"},{"doc":"Gets the pid of the supervisor which supervises the ranch connections. If it cannot be found as child of the given ranch listener supervisor it throws and logs an error.","ref":"Edeliver.Relup.Instructions.CheckRanchConnections.html#ranch_connections_sup/1","title":"Edeliver.Relup.Instructions.CheckRanchConnections.ranch_connections_sup/1","type":"function"},{"doc":"Checks whether the ranch connections can be found. If not the upgrade will be canceled. This function runs twice because it is executed before the &quot;point of no return&quot;, once when checking the relup and once when executing the relup. It also tries to detect the websocket processes if the Phoenix.PubSub.PG2 pubsub backend is used for phoenix websocket channels. It will not fail if that detection is not possible, but a warning is printed","ref":"Edeliver.Relup.Instructions.CheckRanchConnections.html#run/1","title":"Edeliver.Relup.Instructions.CheckRanchConnections.run/1","type":"function"},{"doc":"Returns the pids of the connections which are websocket connections for channels. This detection works only if Phoenix.PubSub.PG2 is used as pubsub backend. If detection fails, it returns :not_detected . Knowing which processes of the known connections are websockets is useful because they should be suspended during the hot code upgrade and resumed again afterwards. If detection fails, websocket connections must be treated as &quot;normal&quot; http request connections. Detection of websocket connections is not possible either by the phoenix api nor by the cowboy / ranch api. That's why this function takes the processes that are monitored by the Phoenix.PubSub.Local process and are a subset of the detected connections as websocket connections for channels. The lookup for Phoenix.PubSub.Local process is dones by searching the supervision tree of the application for: ` Phoenix.Endpoint ` -&gt; ` Phoenix.PubSub.PG2 ` -&gt; ` Phoenix.PubSub.LocalSupervisor ` -&gt; ` Supervisor ` -&gt; ` Phoenix.PubSub.Local `","ref":"Edeliver.Relup.Instructions.CheckRanchConnections.html#websocket_channel_connections/2","title":"Edeliver.Relup.Instructions.CheckRanchConnections.websocket_channel_connections/2","type":"function"},{"doc":"This upgrade instruction does nothing but can be used in an Edeliver.Relup.Modification to indicate that the code_change function is invoked for suspended modules which changed. See Edeliver.Relup.Instructions.SuspendAppProcesses . In a future step it might remove code_change instructions from modules which does not change exported functions.","ref":"Edeliver.Relup.Instructions.CodeChangeOnAppProcesses.html","title":"Edeliver.Relup.Instructions.CodeChangeOnAppProcesses","type":"module"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.CodeChangeOnAppProcesses.html#modify_relup/2","title":"Edeliver.Relup.Instructions.CodeChangeOnAppProcesses.modify_relup/2","type":"function"},{"doc":"Notify request processes that a release upgrade starts. This upgrade instruction waits a short time until current requests finished and notifies the remaining, that a code upgrade will appear. If a phoenix version is used which supports the upgrade notification feature, the remaining requests that did not finish but failed during the upgrade will be replayed with the original request when the code upgrade is done. This instruction should be used in conjunction with and after the Edeliver.Relup.Instructions.SuspendRanchAcceptors instruction which avoids that new requets are accepted during the upgrade. To make sure that the http request connections can be found on the node, use this instruction after the Edeliver.Relup.Instructions.CheckRanchConnections instruction which will abort the upgrade if the http request connections accepted by ranch cannot be found in the supervision tree.","ref":"Edeliver.Relup.Instructions.FinishRunningRequests.html","title":"Edeliver.Relup.Instructions.FinishRunningRequests","type":"module"},{"doc":"Returns name of the application and the timeout in ms to wait until running requests finish. These values taken as argument for the run/1 function","ref":"Edeliver.Relup.Instructions.FinishRunningRequests.html#arguments/2","title":"Edeliver.Relup.Instructions.FinishRunningRequests.arguments/2","type":"function"},{"doc":"Waits until the list of processes terminated. Waits up to timeout ms and the returns the process ids of the processes which are still running","ref":"Edeliver.Relup.Instructions.FinishRunningRequests.html#bulk_wait_for_termination/2","title":"Edeliver.Relup.Instructions.FinishRunningRequests.bulk_wait_for_termination/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.FinishRunningRequests.html#call_this/1","title":"Edeliver.Relup.Instructions.FinishRunningRequests.call_this/1","type":"function"},{"doc":"This module depends on the Edeliver.Relup.Instructions.CheckRanchAcceptors and the Edeliver.Relup.Instructions.CheckRanchConnections module which must be loaded before this instruction for upgrades and unload after this instruction for downgrades.","ref":"Edeliver.Relup.Instructions.FinishRunningRequests.html#dependencies/0","title":"Edeliver.Relup.Instructions.FinishRunningRequests.dependencies/0","type":"function"},{"doc":"Appends this instruction to the instructions after the &quot;point of no return&quot; but before any instruction which loads or unloads new code, (re-)starts or stops any running processes, or (re-)starts or stops any application or the emulator.","ref":"Edeliver.Relup.Instructions.FinishRunningRequests.html#insert_where/0","title":"Edeliver.Relup.Instructions.FinishRunningRequests.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.FinishRunningRequests.html#modify_relup/2","title":"Edeliver.Relup.Instructions.FinishRunningRequests.modify_relup/2","type":"function"},{"doc":"Sends the given event to all processes representing http requests","ref":"Edeliver.Relup.Instructions.FinishRunningRequests.html#notify_running_requests/2","title":"Edeliver.Relup.Instructions.FinishRunningRequests.notify_running_requests/2","type":"function"},{"doc":"Waits timeout milliseconds until current http requests finished and notifies remaining request processes that a code upgrad is running and new code will be loaded. This enables phoenix to rerun requests which failed during code loading.","ref":"Edeliver.Relup.Instructions.FinishRunningRequests.html#run/1","title":"Edeliver.Relup.Instructions.FinishRunningRequests.run/1","type":"function"},{"doc":"This upgrade instruction logs the given info message on the node which runs the upgrade and in the running upgrade script which was started by the $APP/bin/$APP upgrade $RELEASE command. Usage: Edeliver.Relup.Instructions.Info . modify_relup ( config , _up_message = &quot;Synchronizing nodes&quot; , _down_message = &quot;Desynchronizing nodes&quot; , _insert_where = &amp; append_after_point_of_no_return / 2 ) ` Available sections are: :check -&gt; Checks whether upgrade is possible. Before &quot;point of no return&quot; :suspend -&gt; Suspends processes before the upgrade. Right after the &quot;point of no return&quot; :upgrade -&gt; Runs the upgrade by (un-)loading new(/old) code and updating processes and applications :resume -&gt; Resumes processes after the upgrade that were suspended in the :suspend section. :finished -&gt; The upgrade finished successfully","ref":"Edeliver.Relup.Instructions.Info.html","title":"Edeliver.Relup.Instructions.Info","type":"module"},{"doc":"Callback implementation for Edeliver.Relup.RunnableInstruction.arguments/2 .","ref":"Edeliver.Relup.Instructions.Info.html#arguments/2","title":"Edeliver.Relup.Instructions.Info.arguments/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.Info.html#call_this/1","title":"Edeliver.Relup.Instructions.Info.call_this/1","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.RunnableInstruction.dependencies/0 .","ref":"Edeliver.Relup.Instructions.Info.html#dependencies/0","title":"Edeliver.Relup.Instructions.Info.dependencies/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.RunnableInstruction.insert_where/0 .","ref":"Edeliver.Relup.Instructions.Info.html#insert_where/0","title":"Edeliver.Relup.Instructions.Info.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.Info.html#modify_relup/2","title":"Edeliver.Relup.Instructions.Info.modify_relup/2","type":"function"},{"doc":"","ref":"Edeliver.Relup.Instructions.Info.html#modify_relup/5","title":"Edeliver.Relup.Instructions.Info.modify_relup/5","type":"function"},{"doc":"Logs the message on the node which is upgraded and in the upgrade script which was started by the $APP/bin/$APP upgrade $RELEASE command.","ref":"Edeliver.Relup.Instructions.Info.html#run/1","title":"Edeliver.Relup.Instructions.Info.run/1","type":"function"},{"doc":"This upgrade instruction does nothing but can be used in an Edeliver.Relup.Modification to indicate that the changed modules are reloaded at this part of the relup process. In a future step it might sort the modules to reload according to their dependencies.","ref":"Edeliver.Relup.Instructions.ReloadModules.html","title":"Edeliver.Relup.Instructions.ReloadModules","type":"module"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.ReloadModules.html#modify_relup/2","title":"Edeliver.Relup.Instructions.ReloadModules.modify_relup/2","type":"function"},{"doc":"Runs phoenix requests again which failed during hot code upgrade. This upgrade instruction notifies request processes which were handling requests while new code was loaded that they can be rerun if they failed during the upgrade. It is required that a phoenix version is used which supports the upgrade notification feature. This instruction should be used in conjunction with and after the Edeliver.Relup.Instructions.FinishRunningRequests instruction which notifies the request processes that the code upgrade is started. To make sure that the http request connections can be found on the node, use this instruction after the Edeliver.Relup.Instructions.CheckRanchConnections instruction which will abort the upgrade if the http request connections accepted by ranch cannot be found in the supervision tree.","ref":"Edeliver.Relup.Instructions.RerunFailedRequests.html","title":"Edeliver.Relup.Instructions.RerunFailedRequests","type":"module"},{"doc":"Returns name of the application. This name is taken as argument for the run/1 function and is required to access the acceptor processes through the supervision tree","ref":"Edeliver.Relup.Instructions.RerunFailedRequests.html#arguments/2","title":"Edeliver.Relup.Instructions.RerunFailedRequests.arguments/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.RerunFailedRequests.html#call_this/1","title":"Edeliver.Relup.Instructions.RerunFailedRequests.call_this/1","type":"function"},{"doc":"This module depends on the Edeliver.Relup.Instructions.CheckRanchAcceptors , the Edeliver.Relup.Instructions.CheckRanchConnections and the Edeliver.Relup.Instructions.FinishRunningRequests module which must be loaded before this instruction for upgrades and unload after this instruction for downgrades.","ref":"Edeliver.Relup.Instructions.RerunFailedRequests.html#dependencies/0","title":"Edeliver.Relup.Instructions.RerunFailedRequests.dependencies/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.RunnableInstruction.insert_where/0 .","ref":"Edeliver.Relup.Instructions.RerunFailedRequests.html#insert_where/0","title":"Edeliver.Relup.Instructions.RerunFailedRequests.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.RerunFailedRequests.html#modify_relup/2","title":"Edeliver.Relup.Instructions.RerunFailedRequests.modify_relup/2","type":"function"},{"doc":"Notifies request processes which handled http requests during the release upgrade / downgrade that the code loading is finished and that requests that failed during the code loading can be now rerun with the updated code.","ref":"Edeliver.Relup.Instructions.RerunFailedRequests.html#run/1","title":"Edeliver.Relup.Instructions.RerunFailedRequests.run/1","type":"function"},{"doc":"This upgrade instruction does nothing but can be used in an Edeliver.Relup.Modification to indicate that the processes are resumed which use changed callback modules and were suspended by the Edeliver.Relup.Instructions.SuspendAppProcesses instruction. In a future step it might remove resume instructions from modules which does not change exported functions.","ref":"Edeliver.Relup.Instructions.ResumeAppProcesses.html","title":"Edeliver.Relup.Instructions.ResumeAppProcesses","type":"module"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.ResumeAppProcesses.html#modify_relup/2","title":"Edeliver.Relup.Instructions.ResumeAppProcesses.modify_relup/2","type":"function"},{"doc":"This upgrade instruction resumes the websocket processes connected to phoenix channels when the upgrade is done to continue handling channel events. Use this instruction at the end of the upgrade modification if the Edeliver.Relup.Instructions.SuspendChannels is used at the beginning. Make sure that it is used before the Edeliver.Relup.Instructions.ResumeRanchAcceptors instruction to avoid that recently started websockets which were not suspendet are tried to be resumed. Suspending and resuming websocket processes for phoenix channels requires a recent phoenix version which handles sys events for websockets. It also requires that the builtin phoenix pubsub backend Phoenix.PubSub.PG2 is used for the phoenix channels.","ref":"Edeliver.Relup.Instructions.ResumeChannels.html","title":"Edeliver.Relup.Instructions.ResumeChannels","type":"module"},{"doc":"Returns name of the application. This name is taken as argument for the run/1 function and is required to access the acceptor processes through the supervision tree","ref":"Edeliver.Relup.Instructions.ResumeChannels.html#arguments/2","title":"Edeliver.Relup.Instructions.ResumeChannels.arguments/2","type":"function"},{"doc":"Resumes a list of processes. Because resume a process might take a while depending on the length of the message queue or duration of current operation processed by the pid, suspending is done asynchronously for each process by spawning a new process which calls :sys.resume/2 and then waiting for all results before returning from this function. Be careful when using :infinity as timeout, because this function might hang for infinite time if one of the process does not handle sys events.","ref":"Edeliver.Relup.Instructions.ResumeChannels.html#bulk_resume/2","title":"Edeliver.Relup.Instructions.ResumeChannels.bulk_resume/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.ResumeChannels.html#call_this/1","title":"Edeliver.Relup.Instructions.ResumeChannels.call_this/1","type":"function"},{"doc":"This module depends on the Edeliver.Relup.Instructions.CheckRanchAcceptors and the Edeliver.Relup.Instructions.CheckRanchConnections module which must be loaded before this instruction for upgrades and unloaded after this instruction for downgrades.","ref":"Edeliver.Relup.Instructions.ResumeChannels.html#dependencies/0","title":"Edeliver.Relup.Instructions.ResumeChannels.dependencies/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.RunnableInstruction.insert_where/0 .","ref":"Edeliver.Relup.Instructions.ResumeChannels.html#insert_where/0","title":"Edeliver.Relup.Instructions.ResumeChannels.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.ResumeChannels.html#modify_relup/2","title":"Edeliver.Relup.Instructions.ResumeChannels.modify_relup/2","type":"function"},{"doc":"Resumes all websocket channels to continue handling channel events after the upgrade. This is possible only in recent phoenix versions since handling sys events is required for resuming. If an older version is used, a warning is printed that suspending is not supported.","ref":"Edeliver.Relup.Instructions.ResumeChannels.html#run/1","title":"Edeliver.Relup.Instructions.ResumeChannels.run/1","type":"function"},{"doc":"This upgrade instruction resumes the ranch acceptors which were suspended by the Edeliver.Relup.Instructions.SuspendRanchAcceptors instruction at the beginning of the upgrade. Because real suspending of ranch acceptors is not possible because ranch acceptors do not handle sys messages, they were actually terminated and are restarted by this relup instruction.","ref":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.html","title":"Edeliver.Relup.Instructions.ResumeRanchAcceptors","type":"module"},{"doc":"Returns name of the application. This name is taken as argument for the run/1 function and is required to access the acceptor processes through the supervision tree","ref":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.html#arguments/2","title":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.arguments/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.html#call_this/1","title":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.call_this/1","type":"function"},{"doc":"This module requires the Edeliver.Relup.Instructions.CheckRanchAcceptors module which must be loaded before this instruction for upgrades and unload after this instruction for downgrades.","ref":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.html#dependencies/0","title":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.dependencies/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.RunnableInstruction.insert_where/0 .","ref":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.html#insert_where/0","title":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.html#modify_relup/2","title":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.modify_relup/2","type":"function"},{"doc":"Resumes the ranch acceptor supervisor and restarts all ranch acceptors to enable accepting new requests / connections again after the upgrade.","ref":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.html#run/1","title":"Edeliver.Relup.Instructions.ResumeRanchAcceptors.run/1","type":"function"},{"doc":"This upgrade instruction is intended for testing only and just sleeps the given amount of seconds. This can be used to test instructions which suspend processes at the beginning of the upgrade before the new code is installed. Usage: Edeliver.Relup.Instructions.Sleep . modify_relup ( config , _seconds = 30 ) It prints a countown in the upgrade script which was started by the $APP/bin/$APP upgrade $RELEASE command.","ref":"Edeliver.Relup.Instructions.Sleep.html","title":"Edeliver.Relup.Instructions.Sleep","type":"module"},{"doc":"Callback implementation for Edeliver.Relup.RunnableInstruction.arguments/2 .","ref":"Edeliver.Relup.Instructions.Sleep.html#arguments/2","title":"Edeliver.Relup.Instructions.Sleep.arguments/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.Sleep.html#call_this/1","title":"Edeliver.Relup.Instructions.Sleep.call_this/1","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.RunnableInstruction.dependencies/0 .","ref":"Edeliver.Relup.Instructions.Sleep.html#dependencies/0","title":"Edeliver.Relup.Instructions.Sleep.dependencies/0","type":"function"},{"doc":"Appends this instruction to the instructions after the &quot;point of no return&quot; but before any instruction which loads or unloads new code, (re-)starts or stops any running processes, or (re-)starts or stops any application or the emulator.","ref":"Edeliver.Relup.Instructions.Sleep.html#insert_where/0","title":"Edeliver.Relup.Instructions.Sleep.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.Sleep.html#modify_relup/2","title":"Edeliver.Relup.Instructions.Sleep.modify_relup/2","type":"function"},{"doc":"","ref":"Edeliver.Relup.Instructions.Sleep.html#modify_relup/3","title":"Edeliver.Relup.Instructions.Sleep.modify_relup/3","type":"function"},{"doc":"Waits the given amount of seconds and prints a countdown in the upgrade script which was started by the $APP/bin/$APP upgrade $RELEASE command.","ref":"Edeliver.Relup.Instructions.Sleep.html#run/1","title":"Edeliver.Relup.Instructions.Sleep.run/1","type":"function"},{"doc":"Upgrade instruction which replaces :brutal_purge with :soft_purge for :load_module , :load , :update and :remove relup instructions. If :brutal_purge is used, processes running old code are killed. If :soft_purge is used the release handler will refuse to start the upgrade.","ref":"Edeliver.Relup.Instructions.SoftPurge.html","title":"Edeliver.Relup.Instructions.SoftPurge","type":"module"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.SoftPurge.html#modify_relup/2","title":"Edeliver.Relup.Instructions.SoftPurge.modify_relup/2","type":"function"},{"doc":"This upgrade instruction starts a new section and logs that info on the node which runs the upgrade and in the upgrade script started by the $APP/bin/$APP upgrade $RELEASE command. Usage: Edeliver.Relup.Instructions.StartSection . modify_relup ( config , _section = :check ) Available sections are: :check -&gt; Checks whether upgrade is possible. Before &quot;point of no return&quot; :suspend -&gt; Suspends processes before the upgrade. Right after the &quot;point of no return&quot; :upgrade -&gt; Runs the upgrade by (un-)loading new(/old) code and updating processes and applications :resume -&gt; Resumes processes after the upgrade that were suspended in the :suspend section. :finished -&gt; The upgrade finished successfully It uses the Edeliver.Relup.Instructions.Info instruction to display the section information.","ref":"Edeliver.Relup.Instructions.StartSection.html","title":"Edeliver.Relup.Instructions.StartSection","type":"module"},{"doc":"","ref":"Edeliver.Relup.Instructions.StartSection.html#modify_relup/3","title":"Edeliver.Relup.Instructions.StartSection.modify_relup/3","type":"function"},{"doc":"","ref":"Edeliver.Relup.Instructions.StartSection.html#t:section/0","title":"Edeliver.Relup.Instructions.StartSection.section/0","type":"type"},{"doc":"This upgrade instruction does nothing but can be used in an Edeliver.Relup.Modification to indicate that the processes are suspended which use changed callback modules See also Edeliver.Relup.Instructions.ResumeAppProcesses . In a future step it might remove suspend instructions from modules which does not change exported functions and / or group the suspending of the processes in that way, that first all processes are suspended, then all code-changed and in the end resumed instead of performing this steps per module.","ref":"Edeliver.Relup.Instructions.SuspendAppProcesses.html","title":"Edeliver.Relup.Instructions.SuspendAppProcesses","type":"module"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.SuspendAppProcesses.html#modify_relup/2","title":"Edeliver.Relup.Instructions.SuspendAppProcesses.modify_relup/2","type":"function"},{"doc":"This upgrade instruction suspends the websocket processes connected to phoenix channels to avoid that new channel events will be processed during the code upgrade / downgrade process. It will be appended to the instructions after the &quot;point of no return&quot; but before any application code is reloaded. It should be used in conjunction with and after the Edeliver.Relup.Instructions.SuspendRanchAcceptors instruction which avoids that new websockets processes for phoenix channels are started. To make sure that the websocket connections can be found on the node, use this instruction after the Edeliver.Relup.Instructions.CheckRanchConnections instruction which will abort the upgrade if ranch (websocket) connections cannot be found in the supervision tree. Use the Edeliver.Relup.Instructions.ResumeRanchAcceptors instruction at the end of your instructions list to resume the websocket processes and re-enable handling channel messages. Suspending and resuming websocket processes for phoenix channels requires a recent phoenix version which handles sys events for websockets. It also requires that the builtin phoenix pubsub backend Phoenix.PubSub.PG2 is used for the phoenix channels.","ref":"Edeliver.Relup.Instructions.SuspendChannels.html","title":"Edeliver.Relup.Instructions.SuspendChannels","type":"module"},{"doc":"Returns name of the application. This name is taken as argument for the run/1 function and is required to access the acceptor processes through the supervision tree","ref":"Edeliver.Relup.Instructions.SuspendChannels.html#arguments/2","title":"Edeliver.Relup.Instructions.SuspendChannels.arguments/2","type":"function"},{"doc":"Suspends a list of processes. Because suspending a process might take a while depending on the length of the message queue or duration of current operation processed by the pid, suspending is done asynchronously for each process by spawning a new process which calls :sys.suspend/2 and then waiting for all results before returning from this function. Be careful when using :infinity as timeout, because this function might hang for infinite time if one of the process does not handle sys events.","ref":"Edeliver.Relup.Instructions.SuspendChannels.html#bulk_suspend/2","title":"Edeliver.Relup.Instructions.SuspendChannels.bulk_suspend/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.SuspendChannels.html#call_this/1","title":"Edeliver.Relup.Instructions.SuspendChannels.call_this/1","type":"function"},{"doc":"This module depends on the Edeliver.Relup.Instructions.CheckRanchAcceptors and the Edeliver.Relup.Instructions.CheckRanchConnections module which must be loaded before this instruction for upgrades and unload after this instruction for downgrades.","ref":"Edeliver.Relup.Instructions.SuspendChannels.html#dependencies/0","title":"Edeliver.Relup.Instructions.SuspendChannels.dependencies/0","type":"function"},{"doc":"Appends this instruction to the instructions after the &quot;point of no return&quot; but before any instruction which loads or unloads new code, (re-)starts or stops any running processes, or (re-)starts or stops any application or the emulator.","ref":"Edeliver.Relup.Instructions.SuspendChannels.html#insert_where/0","title":"Edeliver.Relup.Instructions.SuspendChannels.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.SuspendChannels.html#modify_relup/2","title":"Edeliver.Relup.Instructions.SuspendChannels.modify_relup/2","type":"function"},{"doc":"Suspends all websocket channels to avoid handling new channel events during the upgrade. This is possible only in recent phoenix versions since handling sys events is required for suspending. If an older version is used, a warning is printed that suspending is not supported.","ref":"Edeliver.Relup.Instructions.SuspendChannels.html#run/1","title":"Edeliver.Relup.Instructions.SuspendChannels.run/1","type":"function"},{"doc":"This upgrade instruction suspends the ranch acceptors to avoid that new connections will be accepted. It will be inserted right after the &quot;point of no return&quot;. When the upgrade is done, the Edeliver.Relup.Instructions.ResumeRanchAcceptors instruction reenables the acceptors again. To make sure that the ranch acceptors are found, use this instruction after the Edeliver.Relup.Instructions.CheckRanchAcceptors instruction which will abort the upgrade if the acceptors cannot be found. Because real suspending of ranch acceptors is not possible because ranch acceptors do not handle sys messages, they are actually terminated. Unfortunately the ranch acceptor supervisor cannot be suspended in addition to avoid starting new acceptors, because supervisors can't be suspended because the supervision tree is used to find processes which uses callback modules. Since no acceptors are started dynamically this can be ignored. Use the Edeliver.Relup.Instructions.ResumeRanchAcceptors instruction at the end of your instructions list to re-enable accepting tcp connection when the upgrade is done.","ref":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.html","title":"Edeliver.Relup.Instructions.SuspendRanchAcceptors","type":"module"},{"doc":"Returns name of the application. This name is taken as argument for the run/1 function and is required to access the acceptor processes through the supervision tree","ref":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.html#arguments/2","title":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.arguments/2","type":"function"},{"doc":"Calls the run/1 function of this module from the relup file during hot code upgrade","ref":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.html#call_this/1","title":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.call_this/1","type":"function"},{"doc":"This module requires the Edeliver.Relup.Instructions.CheckRanchAcceptors module which must be loaded before this instruction for upgrades and unload after this instruction for downgrades.","ref":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.html#dependencies/0","title":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.dependencies/0","type":"function"},{"doc":"Appends this instruction to the instructions after the &quot;point of no return&quot; but before any instruction which loads or unloads new code, (re-)starts or stops any running processes, or (re-)starts or stops any application or the emulator.","ref":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.html#insert_where/0","title":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.insert_where/0","type":"function"},{"doc":"Callback implementation for Edeliver.Relup.Instruction.modify_relup/2 .","ref":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.html#modify_relup/2","title":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.modify_relup/2","type":"function"},{"doc":"Suspends all ranch acceptors to avoid handling new requests / connections during the upgrade. Because suspending of ranch acceptors is not possible they are terminated. In addition the ranch acceptor supervisor is suspended to avoid starting new acceptors.","ref":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.html#run/1","title":"Edeliver.Relup.Instructions.SuspendRanchAcceptors.run/1","type":"function"},{"doc":"This behaviour can be used to provide custom modifications of relup instructions when a release upgrade is built by edeliver. By default the implementation from Edeliver.Relup.PhoenixModification is used for phoenix applications and for all others the implementation from Edeliver.Relup.DefaultModification . Implementations can modify the relup instructions step by step by using modules implementing the Edeliver.Relup.Instruction behaviour. The implementation returning the highest priority/0 or which is passed by the --relup-mod= command line option will be used unless the --skip-relup-mod option is set. Example: defmodule Acme.Relup.Modification do use Edeliver.Relup.Modification def modify_relup ( instructions = % Instructions { } , config = %{ } ) do instructions |&gt; Edeliver.Relup.DefaultModification . modify_relup ( config ) # use default modifications |&gt; log_upgrade # add custom modification which logs the upgrade end defp log_upgrade ( instructions = % Instructions { up_instructions : up_instructions } ) do log_instruction = { apply , { :Elixir . Logger , info , [ &lt;&lt; &quot;Upgraded successfully&quot; &gt;&gt; ] } } %{ instructions | up_instructions : [ log_instruction | up_instructions ] } end end","ref":"Edeliver.Relup.Modification.html","title":"Edeliver.Relup.Modification","type":"behaviour"},{"doc":"Modifies the relup instructions and returns the modified instruction","ref":"Edeliver.Relup.Modification.html#c:modify_relup/2","title":"Edeliver.Relup.Modification.modify_relup/2","type":"callback"},{"doc":"Default priority for builtin relup modifications","ref":"Edeliver.Relup.Modification.html#priority_default/0","title":"Edeliver.Relup.Modification.priority_default/0","type":"function"},{"doc":"Priority lower as the default priority which can be used temporarily to disable user defined relup modifications and use the defaults","ref":"Edeliver.Relup.Modification.html#priority_none/0","title":"Edeliver.Relup.Modification.priority_none/0","type":"function"},{"doc":"Default priority for user defined relup modificaitons","ref":"Edeliver.Relup.Modification.html#priority_user/0","title":"Edeliver.Relup.Modification.priority_user/0","type":"function"},{"doc":"This module provides default modifications of the relup instructions for phoenix apps. It performs the following steps: Checking whether the upgrade is possible by checking whether there are processes running old code (from a previous upgrade) by checking whether the ranch acceptor processes can be found by checking whether ranch connection processes can be found or canceling the upgrade if one of the checks fails. Preparing the upgrade by suspending all ranch acceptors to avoid accepting new connections / requests during the hot code upgrade by suspending phoenix channels by waiting a short time until running requests are finished and notifying the remaining that an upgrades starts (this allows to rerun failed requests later) Executing the upgrade by using :soft_purge instead of :brutal_purge when loading new code by suspending all processes running code of changed modules by calling code_change at this processes by resuming that processes Finishing the upgrade by rerunning requests that failed during the upgrade by resuming all phoenix channels by resuming all ranch acceptors to continue accepting new connections","ref":"Edeliver.Relup.PhoenixModification.html","title":"Edeliver.Relup.PhoenixModification","type":"module"},{"doc":"Callback implementation for Edeliver.Relup.Modification.modify_relup/2 .","ref":"Edeliver.Relup.PhoenixModification.html#modify_relup/2","title":"Edeliver.Relup.PhoenixModification.modify_relup/2","type":"function"},{"doc":"Returns the priority Edeliver.Relup.Modification.priority_default/0 +1 . Unless the module is set by the RELUP_MODIFICATION_MODULE env or the --relup-mod= command line option the module with the highest priority is used (which is also usable).","ref":"Edeliver.Relup.PhoenixModification.html#priority/0","title":"Edeliver.Relup.PhoenixModification.priority/0","type":"function"},{"doc":"Returns true if the current project is a phoenix project","ref":"Edeliver.Relup.PhoenixModification.html#usable?/1","title":"Edeliver.Relup.PhoenixModification.usable?/1","type":"function"},{"doc":"This module can be used to provide custom instructions executed during the upgrade. They can be used in implementations of the Edeliver.Relup.Modification behaviours. A runnable instruction must implement a Edeliver.Relup.RunnableInstruction.run/1 function which will be executed during the upgrade on the nodes. Example: defmodule Acme.Relup.PingNodeInstruction do use Edeliver.Relup.RunnableInstruction def modify_relup ( instructions = % Instructions { up_instructions : up_instructions } , _config = %{ } ) do node_name = :&quot;node@host&quot; %{ instructions | up_instructions : [ call_this ( [ node_name ] ) | instructions . up_instructions ] , down_instructions : [ call_this ( [ node_name ] ) | instructions . down_instructions ] } end # executed during hot code upgrade from relup file def run ( _options = [ node_name ] ) do :net_adm . ping ( node_name ) end # actually implemented already in this module def call_this ( arguments ) do # creates a relup instruction to call `run/1` of this module { :apply , { __MODULE__ , :run , arguments } } end end # using the instruction defmodule Acme.Relup.Modification do use Edeliver.Relup.Modification def modify_relup ( instructions = % Instructions { } , config = %{ } ) do instructions |&gt; Edeliver.Relup.DefaultModification . modify_relup ( config ) # use default modifications |&gt; Acme.Relup.PingNodeInstruction . modify_relup ( config ) # apply also custom instructions end end","ref":"Edeliver.Relup.RunnableInstruction.html","title":"Edeliver.Relup.RunnableInstruction","type":"behaviour"},{"doc":"Returns the arguments which will be passed the Edeliver.Relup.RunnableInstruction.run/1 function during the upgrade. Default is an empty list.","ref":"Edeliver.Relup.RunnableInstruction.html#c:arguments/2","title":"Edeliver.Relup.RunnableInstruction.arguments/2","type":"callback"},{"doc":"Assumes that the pattern matches or throws an error with the given error message. The error message is logged as error to the logfile using the Logger and displayed as error output by the $APP/bin/$APP upgrade $RELEASE task using the $APP/ebin/install_upgrade.escript script. If the pattern matches the variables from the matching are assigned.","ref":"Edeliver.Relup.RunnableInstruction.html#assume/2","title":"Edeliver.Relup.RunnableInstruction.assume/2","type":"macro"},{"doc":"Logs a debug message using the Logger on the running node which is upgraded. In addition the same debug message is logged on the node which executes the upgrade and is displayed as output of the $APP/bin/$APP upgrade $RELEASE command.","ref":"Edeliver.Relup.RunnableInstruction.html#debug/1","title":"Edeliver.Relup.RunnableInstruction.debug/1","type":"function"},{"doc":"Returns a list of module names which implement the behaviour Edeliver.Relup.RunnableInstruction and are used / referenced by this runnable instruction. These modules must be loaded before this instruction is executed for upgrades and unloaded after this instruction for downgrades. Default is an empty list.","ref":"Edeliver.Relup.RunnableInstruction.html#c:dependencies/0","title":"Edeliver.Relup.RunnableInstruction.dependencies/0","type":"callback"},{"doc":"Ensures that all Edeliver.Relup.RunnableInstruction modules used / referenced by this instruction and returned by the Edeliver.Relup.RunnableInstruction.dependencies/0 callback are loaded before this instruction is executed during the upgrade.","ref":"Edeliver.Relup.RunnableInstruction.html#ensure_dependencies_loaded_before_instruction_for_upgrade/3","title":"Edeliver.Relup.RunnableInstruction.ensure_dependencies_loaded_before_instruction_for_upgrade/3","type":"function"},{"doc":"Ensures that all Edeliver.Relup.RunnableInstruction modules used / referenced by this instruction and returned by the Edeliver.Relup.RunnableInstruction.dependencies/0 callback are unloaded after this instruction is executed during the downgrade.","ref":"Edeliver.Relup.RunnableInstruction.html#ensure_dependencies_unloaded_after_instruction_for_downgrade/3","title":"Edeliver.Relup.RunnableInstruction.ensure_dependencies_unloaded_after_instruction_for_downgrade/3","type":"function"},{"doc":"Logs an error using the Logger on the running node which is upgraded. In addition the same error message is logged on the node which executes the upgrade and is displayed as output of the $APP/bin/$APP upgrade $RELEASE command.","ref":"Edeliver.Relup.RunnableInstruction.html#error/1","title":"Edeliver.Relup.RunnableInstruction.error/1","type":"function"},{"doc":"Formats and prints the message on the node running the upgrade script which was started by the $APP/bin/$APP upgrade $RELEASE command.","ref":"Edeliver.Relup.RunnableInstruction.html#format_in_upgrade_script/2","title":"Edeliver.Relup.RunnableInstruction.format_in_upgrade_script/2","type":"function"},{"doc":"Logs an info message using the Logger on the running node which is upgraded. In addition the same info message is logged on the node which executes the upgrade and is displayed as output of the $APP/bin/$APP upgrade $RELEASE command.","ref":"Edeliver.Relup.RunnableInstruction.html#info/1","title":"Edeliver.Relup.RunnableInstruction.info/1","type":"function"},{"doc":"Returns a function which inserts the relup instruction that calls the Edeliver.Relup.RunnableInstruction.run/1 function of this module. Default is inserting it at the end of the instructions","ref":"Edeliver.Relup.RunnableInstruction.html#c:insert_where/0","title":"Edeliver.Relup.RunnableInstruction.insert_where/0","type":"callback"},{"doc":"Logs the message of the given type on the node which executes the upgrade and displays it as output of the $APP/bin/$APP upgrade $RELEASE command. The message is prefixed with a string derived from the message type.","ref":"Edeliver.Relup.RunnableInstruction.html#log_in_upgrade_script/2","title":"Edeliver.Relup.RunnableInstruction.log_in_upgrade_script/2","type":"function"},{"doc":"The function to run during hot code upgrade on nodes. If it throws an error before the point_of_no_return the upgrade is aborted. If it throws an error and was executed after that point, the release is restarted","ref":"Edeliver.Relup.RunnableInstruction.html#c:run/1","title":"Edeliver.Relup.RunnableInstruction.run/1","type":"callback"},{"doc":"Logs a warning using the Logger on the running node which is upgraded. In addition the same warning message is logged on the node which executes the upgrade and is displayed as output of the $APP/bin/$APP upgrade $RELEASE command.","ref":"Edeliver.Relup.RunnableInstruction.html#warn/1","title":"Edeliver.Relup.RunnableInstruction.warn/1","type":"function"},{"doc":"Provides functions to move relup instructions to a given position which can be used in Edeliver.Relup.Instruction behaviour implementations in the relup file to fulfill some requirements.","ref":"Edeliver.Relup.ShiftInstruction.html","title":"Edeliver.Relup.ShiftInstruction","type":"module"},{"doc":"Ensures that the module of Edeliver.Relup.RunnableInstruction is loaded before it is executed. E.g. if an Edeliver.Relup.Instructions.Info instruction implements the behaviour Edeliver.Relup.RunnableInstruction it creates and inserts a: { :apply , { Elixir.Edeliver.Relup.Instructions.Info , :run , [ &quot;hello&quot; ] } } relup instruction. This function ensures that the instruction which loads that module is placed before that instruction. This is essential if the Edeliver.Relup.RunnableInstruction is new and was not included into the old version of the release or has changed in the new version.","ref":"Edeliver.Relup.ShiftInstruction.html#ensure_module_loaded_before_first_runnable_instructions/2","title":"Edeliver.Relup.ShiftInstruction.ensure_module_loaded_before_first_runnable_instructions/2","type":"function"},{"doc":"Ensures that the given module is loaded before the first occurrence of the runnable instruction. If an %Edeliver.Relup.Instructions{} is given containing also the down instructions, it ensures that the module is unloaded after the last occurrence of the runnable down instruction. Use this function instead of the ensure_module_loaded_before_instruction/3 function if the Edeliver.Relup.RunnableInstruction can be used several times in a Edeliver.Relup.Modification . If the module did not change and was already included into the old release this function has no effect.","ref":"Edeliver.Relup.ShiftInstruction.html#ensure_module_loaded_before_first_runnable_instructions/3","title":"Edeliver.Relup.ShiftInstruction.ensure_module_loaded_before_first_runnable_instructions/3","type":"function"},{"doc":"Ensures that the given module is loaded before the given instruction (if it needs to be loaded). If an %Edeliver.Relup.Instructions{} is given containing also the down instructions, it ensures that the module is unloaded after the instruction for the down instructions. Use this function only, if the instruction should be used only once in a Relup.Modification for the up or down instructions. Use the ensure_module_loaded_before_first_runnable_instructions/2 function instead if the RunnableInstruction can be used several times in a Relup.Modification .","ref":"Edeliver.Relup.ShiftInstruction.html#ensure_module_loaded_before_instruction/3","title":"Edeliver.Relup.ShiftInstruction.ensure_module_loaded_before_instruction/3","type":"function"},{"doc":"Ensures that the given module is (un)loaded after the given instruction (if it needs to be (un)loaded). If an %Edeliver.Relup.Instructions{} is given containing also the down instructions, it ensures that the module is (un)loaded before the instruction for the down instructions. Use this function only, if the instruction should be used only once in a Relup.Modification for the up or down instructions. Use the ensure_module_unloaded_after_last_runnable_instruction/2 function instead if the RunnableInstruction can be used several times in a Relup.Modification .","ref":"Edeliver.Relup.ShiftInstruction.html#ensure_module_unloaded_after_instruction/3","title":"Edeliver.Relup.ShiftInstruction.ensure_module_unloaded_after_instruction/3","type":"function"},{"doc":"Ensures that the module of Edeliver.Relup.RunnableInstruction is unloaded after it was executed. E.g. if an Edeliver.Relup.Instructions.Info instruction implements the behaviour Edeliver.Relup.RunnableInstruction it creates and inserts a { :apply , { Elixir.Edeliver.Relup.Instructions.Info , :run , [ &quot;hello&quot; ] } } relup instruction. This function ensures that the instruction which unloads that module is placed after that instruction. This is essential if the Edeliver.Relup.RunnableInstruction was changed and the new version is unloaded in the downgrade instructions.","ref":"Edeliver.Relup.ShiftInstruction.html#ensure_module_unloaded_after_last_runnable_instruction/2","title":"Edeliver.Relup.ShiftInstruction.ensure_module_unloaded_after_last_runnable_instruction/2","type":"function"},{"doc":"Ensures that the given module is (un)loaded after the last occurrenct of the given runnable instruction. If an %Edeliver.Relup.Instructions{} is given containing also the down instructions, it ensures that the module is loaded before the first occurrence of the runnable instruction for the down instructions. Use this function instead of the ensure_module_unloaded_after_instruction/3 function if the RunnableInstruction can be used several times in a Relup.Modification .","ref":"Edeliver.Relup.ShiftInstruction.html#ensure_module_unloaded_after_last_runnable_instruction/3","title":"Edeliver.Relup.ShiftInstruction.ensure_module_unloaded_after_last_runnable_instruction/3","type":"function"},{"doc":"Returns the first occurrence of a RunnableInstruction implemented by the given module.","ref":"Edeliver.Relup.ShiftInstruction.html#first_runnable_instruction/2","title":"Edeliver.Relup.ShiftInstruction.first_runnable_instruction/2","type":"function"},{"doc":"Monitors application start progress. This module can be added as additional error report handler using :error_logger.add_report_handler/1 and handles progress reports from started applications and prints that information on the hidden node that called Edeliver.monitor_startup_progress/2 as rpc call to wait until the release started after the asynchronous bin/$APP start command was executed.","ref":"Edeliver.StartupProgress.html","title":"Edeliver.StartupProgress","type":"module"},{"doc":"Handles progress reports from started applications and prints that info on the hidden node that called Edeliver.monitor_startup_progress/2 as rpc call to wait until the release started after the asynchronous bin/$APP start command was executed","ref":"Edeliver.StartupProgress.html#handle_event/2","title":"Edeliver.StartupProgress.handle_event/2","type":"function"},{"doc":"State / Options passed to this report handler","ref":"Edeliver.StartupProgress.html#t:t/0","title":"Edeliver.StartupProgress.t/0","type":"type"},{"doc":"Build and deploy Elixir applications and perform hot-code upgrades Usage: mix edeliver &lt;build-command|deploy-command|node-command|local-command&gt; command-info [Options] mix edeliver --help|--version mix edeliver help &lt;command&gt; Build Commands: mix edeliver build release [--revision=&lt;git-revision&gt;|--tag=&lt;git-tag&gt;] [--branch=&lt;git-branch&gt;] [Options] mix edeliver build appups|upgrade --from=&lt;git-tag-or-revision&gt;|--with=&lt;release-version-from-store&gt; [--to=&lt;git-tag-or-revision&gt;] [--branch=&lt;git-branch&gt;] [Options] Deploy Commands: mix edeliver deploy release|upgrade [[to] staging|production] [--version=&lt;release-version&gt;] [Options] mix edeliver upgrade [staging|production] [--to=&lt;git-tag-or-revision&gt;] [--branch=&lt;git-branch&gt;] [Options] mix edeliver update [staging|production] [--to=&lt;git-tag-or-revision&gt;] [--branch=&lt;git-branch&gt;] [Options] Node Commands: mix edeliver start|stop|restart|ping|version [staging|production] [Options] mix edeliver migrate [staging|production] [up|down] [--version=&lt;migration-version&gt;] mix edeliver [show] migrations [on] [staging|production] Local Commands: mix edeliver check release|config [--version=&lt;release-version&gt;] mix edeliver show releases|appups mix edeliver show relup &lt;xyz.upgrade.tar.gz&gt; mix edeliver edit relup|appups [--version=&lt;release-version&gt;] mix edeliver upload|download [release|upgrade &lt;release-version&gt;]|&lt;src-file-name&gt; [&lt;dest-file-name&gt;] mix edeliver increase [major|minor] versions [--from=&lt;git-tag-or-revision&gt;] [--to=&lt;git-tag-or-revision&gt;] mix edeliver unpack|pack release|upgrade [--version=&lt;release-version&gt;] Command line Options --quiet - do not output verbose messages --only - only fetch dependencies for given environment -C , --compact Displays every task as it's run, silences all output. (default mode) -V , --verbose Same as above, does not silence output. -P , --plain Displays every task as it's run, silences all output. No colouring. (CI) -D , --debug Runs in shell debug mode, displays everything. -S , --skip-existing Skip copying release archives if they exist already on the deploy hosts. -F , --force Do not ask, just do, overwrite, delete or destroy everything --clean-deploy Delete the release, lib and erts-* directories before deploying the release --start-deploy Starts the deployed release. If release is running, it is restarted! --host=[u@]vwx.yz Run command only on that host, even if different hosts are configured --skip-git-clean Don't build from a clean state for faster builds. By default all built files are removed before the next build using git clean . This can be adjusted by the $GIT_CLEAN_PATHS env. --skip-mix-clean Skip the 'mix clean step' for faster builds. Makes only sense in addition to the --skip-git-clean --skip-relup-mod Skip modification of relup file. Custom relup instructions are not added --relup-mod=&lt;module-name&gt; The name of the module to modify the relup --auto-version=revision|commit-count|branch|date Automatically append metadata to release version. --increment-version=major|minor|patch Increment the version for the current build. --set-version=&lt;release-version&gt; Set the release version for the current build. --mix-env=&lt;env&gt; Build with custom mix env $MIX_ENV. Default is 'prod'","ref":"Mix.Tasks.Edeliver.html","title":"Mix.Tasks.Edeliver","type":"task"},{"doc":"Forwards stdin to the edeliver script which was spawned as port.","ref":"Mix.Tasks.Edeliver.html#forward_stdin/1","title":"Mix.Tasks.Edeliver.forward_stdin/1","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Edeliver.html#run/1","title":"Mix.Tasks.Edeliver.run/1","type":"function"},{"doc":"Displays the release version or modifies it before building the release. This task can be used in conjunction with the release task to modify the version for the release / upgrade. The compiled files must be cleaned before and the release task must be executed after. Increasing version and appending metadata to the version can be combined, e.g: mix do clean, release.version increment minor append-git-revision append-branch, release To automatically append metadata, you can set the $AUTO_VERSION environment variable. Usage: mix release.version show mix do clean, release.version Append-Metadata... [Option], release mix do clean, release.version increment [patch|minor|major] [version] [Append-Metadata...] [Option], release mix do clean, release.version set &lt;new-version&gt; [Append-Metadata...] [Option], release Append-Metadata [append-][git-]revision Appends sha1 git revision of current HEAD [append-][git-]branch[-unless-master] Appends the current branch that is built. If -unless-master is used, the branch is only appended unless it is the master branch. [append-][build-]date Appends the build date as YYYYMMDD [append-][build-]time Appends the build date as HHMMSS [append-][git-]commit-count[-all[-branches]|-branch] Appends the number of commits [append-]mix-env Appends the mix environment used while building the release from the current branch or across all branches (default). Appending the commit count from the current branch makes more sense, if the branch name is also appended as metadata to avoid conflicts from different branches. Version Modification show Displays the current release version. increment Increments the release version for the current build patch Increments the patch version (default). The last part of a tripartite version. minor Increments the minor version. The middle part of a tripartite version. major Increments the major version. The first part of a tripartite version. set &lt;new-version&gt; Sets the release version for the current build Options -V , --verbose Verbose output -Q , --quiet Print only errors while modifying version -D , --dry-run Print only new version without changing it Environment Variables AUTO_VERSION as long no arguments are passed directly which append metadata to the version (flags from the Append-Metadata section) the values from that env are used to append metadata. Example MIX_ENV=prod mix do clean, release.version append-git-revision, release","ref":"Mix.Tasks.Release.Version.html","title":"Mix.Tasks.Release.Version","type":"task"},{"doc":"Gets the current branch that will be built. Since the git repository on the build host is usually in a detached state because a specific revision is checked out when building (see git_reset_remote() in libexec/common ), this won't work: git rev-parse --abbrev-ref HEAD Instead git branch --contains &lt;revision&gt; could be used. But the commit/revision can still be in several branches, e.g. if one branch containing that commit was built before and that branch is later merged and built again. Then the old branch exists still on the build host and the commit exists in both branches. So whenever possible we will pass the branch which is built as BRANCH env, but as fallback we try to autodetect the branch which contains the current commit that is built.","ref":"Mix.Tasks.Release.Version.html#get_branch/0","title":"Mix.Tasks.Release.Version.get_branch/0","type":"function"},{"doc":"Gets the current number of commits across all branches","ref":"Mix.Tasks.Release.Version.html#get_commit_count/0","title":"Mix.Tasks.Release.Version.get_commit_count/0","type":"function"},{"doc":"Gets the current number of commits in the current branch","ref":"Mix.Tasks.Release.Version.html#get_commit_count_branch/0","title":"Mix.Tasks.Release.Version.get_commit_count_branch/0","type":"function"},{"doc":"Gets the current date in the form yyyymmdd","ref":"Mix.Tasks.Release.Version.html#get_date/0","title":"Mix.Tasks.Release.Version.get_date/0","type":"function"},{"doc":"Gets the current revision of the git repository edeliver is used as deploy tool for. The sha1 hash containing 7 hexadecimal characters is returned.","ref":"Mix.Tasks.Release.Version.html#get_git_revision/0","title":"Mix.Tasks.Release.Version.get_git_revision/0","type":"function"},{"doc":"Gets the current date in the form hhmmss","ref":"Mix.Tasks.Release.Version.html#get_time/0","title":"Mix.Tasks.Release.Version.get_time/0","type":"function"},{"doc":"Gets the version which should be set as fixed version (instead of incrementing) from the args and returns the args without that value.","ref":"Mix.Tasks.Release.Version.html#get_version_to_set_from_args/2","title":"Mix.Tasks.Release.Version.get_version_to_set_from_args/2","type":"function"},{"doc":"Modifies the current release version by applying the modification_fun s which were collected while parsing the args. If there was an error parsing the arguments passed to this task, this function prints the error and exists the erlang vm, meaning aborting the mix task. If :show is returned from parsing the arguments, this function just prints the current release version.","ref":"Mix.Tasks.Release.Version.html#modify_version/2","title":"Mix.Tasks.Release.Version.modify_version/2","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_branch/1","title":"Mix.Tasks.Release.Version.modify_version_branch/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_branch_unless_master/1","title":"Mix.Tasks.Release.Version.modify_version_branch_unless_master/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_commit_count/1","title":"Mix.Tasks.Release.Version.modify_version_commit_count/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_commit_count_branch/1","title":"Mix.Tasks.Release.Version.modify_version_commit_count_branch/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_date/1","title":"Mix.Tasks.Release.Version.modify_version_date/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_major/1","title":"Mix.Tasks.Release.Version.modify_version_major/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_minor/1","title":"Mix.Tasks.Release.Version.modify_version_minor/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_mix_env/1","title":"Mix.Tasks.Release.Version.modify_version_mix_env/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_patch/1","title":"Mix.Tasks.Release.Version.modify_version_patch/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_revision/1","title":"Mix.Tasks.Release.Version.modify_version_revision/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_set/2","title":"Mix.Tasks.Release.Version.modify_version_set/2","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#modify_version_time/1","title":"Mix.Tasks.Release.Version.modify_version_time/1","type":"function"},{"doc":"Normalizes the arguments passed to this task. This is done by splitting arguments separated by a + , removing leading append- -git and -build strings and renaming commit-count to commit_count","ref":"Mix.Tasks.Release.Version.html#normalize_args/1","title":"Mix.Tasks.Release.Version.normalize_args/1","type":"function"},{"doc":"Parses the arguments passed to this release.version task and merges them with the AUTO_VERSION environment variable. This arguments must not contain any output flags like -V or -Q .","ref":"Mix.Tasks.Release.Version.html#parse_args/1","title":"Mix.Tasks.Release.Version.parse_args/1","type":"function"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Release.Version.html#run/1","title":"Mix.Tasks.Release.Version.run/1","type":"function"},{"doc":"Sorts the args in that way , that all args incrementing or setting the version come first and all args appending metadata come last by not changing their particular order .","ref":"Mix.Tasks.Release.Version.html#sort_args_append_metadata_last/3","title":"Mix.Tasks.Release.Version.sort_args_append_metadata_last/3","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#valid_semver_metadata/1","title":"Mix.Tasks.Release.Version.valid_semver_metadata/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#t:modification_arg/0","title":"Mix.Tasks.Release.Version.modification_arg/0","type":"type"},{"doc":"","ref":"Mix.Tasks.Release.Version.html#t:modification_fun/0","title":"Mix.Tasks.Release.Version.modification_fun/0","type":"type"},{"doc":"Distillery plugin to link the vm.args or sys.config file on deploy hosts. Because distillery uses :systools_make.make_tar(...) to create the release tar which resolves all links using the :dereference option, the release tar needs to be repackaged including the links. To be able use this plugin, it must be added in the rel/config.exs distillery config as plugin like this: environment :prod do .. plugin Releases.Plugin.LinkConfig end","ref":"Releases.Plugin.LinkConfig.html","title":"Releases.Plugin.LinkConfig","type":"module"},{"doc":"","ref":"Releases.Plugin.LinkConfig.html#after_assembly/1","title":"Releases.Plugin.LinkConfig.after_assembly/1","type":"function"},{"doc":"Callback implementation for Distillery.Releases.Plugin.after_assembly/2 .","ref":"Releases.Plugin.LinkConfig.html#after_assembly/2","title":"Releases.Plugin.LinkConfig.after_assembly/2","type":"function"},{"doc":"Callback implementation for Distillery.Releases.Plugin.after_cleanup/2 .","ref":"Releases.Plugin.LinkConfig.html#after_cleanup/2","title":"Releases.Plugin.LinkConfig.after_cleanup/2","type":"function"},{"doc":"","ref":"Releases.Plugin.LinkConfig.html#after_package/1","title":"Releases.Plugin.LinkConfig.after_package/1","type":"function"},{"doc":"Callback implementation for Distillery.Releases.Plugin.after_package/2 .","ref":"Releases.Plugin.LinkConfig.html#after_package/2","title":"Releases.Plugin.LinkConfig.after_package/2","type":"function"},{"doc":"","ref":"Releases.Plugin.LinkConfig.html#before_assembly/1","title":"Releases.Plugin.LinkConfig.before_assembly/1","type":"function"},{"doc":"Callback implementation for Distillery.Releases.Plugin.before_assembly/2 .","ref":"Releases.Plugin.LinkConfig.html#before_assembly/2","title":"Releases.Plugin.LinkConfig.before_assembly/2","type":"function"},{"doc":"","ref":"Releases.Plugin.LinkConfig.html#before_package/1","title":"Releases.Plugin.LinkConfig.before_package/1","type":"function"},{"doc":"Callback implementation for Distillery.Releases.Plugin.before_package/2 .","ref":"Releases.Plugin.LinkConfig.html#before_package/2","title":"Releases.Plugin.LinkConfig.before_package/2","type":"function"},{"doc":"Distillery plugin to auto-patch the relup file when building upgrades. To be able use this plugin, it must be added in the rel/config.exs distillery config as plugin like this: environment :prod do .. plugin Releases.Plugin.ModifyRelup end","ref":"Releases.Plugin.ModifyRelup.html","title":"Releases.Plugin.ModifyRelup","type":"module"},{"doc":"","ref":"Releases.Plugin.ModifyRelup.html#after_assembly/1","title":"Releases.Plugin.ModifyRelup.after_assembly/1","type":"function"},{"doc":"Callback implementation for Distillery.Releases.Plugin.after_assembly/2 .","ref":"Releases.Plugin.ModifyRelup.html#after_assembly/2","title":"Releases.Plugin.ModifyRelup.after_assembly/2","type":"function"},{"doc":"Callback implementation for Distillery.Releases.Plugin.after_cleanup/2 .","ref":"Releases.Plugin.ModifyRelup.html#after_cleanup/2","title":"Releases.Plugin.ModifyRelup.after_cleanup/2","type":"function"},{"doc":"","ref":"Releases.Plugin.ModifyRelup.html#after_package/1","title":"Releases.Plugin.ModifyRelup.after_package/1","type":"function"},{"doc":"Callback implementation for Distillery.Releases.Plugin.after_package/2 .","ref":"Releases.Plugin.ModifyRelup.html#after_package/2","title":"Releases.Plugin.ModifyRelup.after_package/2","type":"function"},{"doc":"","ref":"Releases.Plugin.ModifyRelup.html#before_assembly/1","title":"Releases.Plugin.ModifyRelup.before_assembly/1","type":"function"},{"doc":"Callback implementation for Distillery.Releases.Plugin.before_assembly/2 .","ref":"Releases.Plugin.ModifyRelup.html#before_assembly/2","title":"Releases.Plugin.ModifyRelup.before_assembly/2","type":"function"},{"doc":"","ref":"Releases.Plugin.ModifyRelup.html#before_package/1","title":"Releases.Plugin.ModifyRelup.before_package/1","type":"function"},{"doc":"Callback implementation for Distillery.Releases.Plugin.before_package/2 .","ref":"Releases.Plugin.ModifyRelup.html#before_package/2","title":"Releases.Plugin.ModifyRelup.before_package/2","type":"function"},{"doc":"1.9.0 Enhancements support building in docker instead on a build host support building deployable docker containers containing the built release support mix release task run epmd-less in docker rebar3 support Fixes consider env when fetching deps consider DEPLOY_ENVIRONMENT when globally set 1.8.0 Backwards incompatible changes Elixir 1.10 compatibility by @progsmile. This is minimum required version now. 1.7.0 Backwards incompatible changes Elixir 1.9 compatibility by @pablo-meier. This is minimum required version now. Distillery 2.1.0 compatibility by @nifoc. This is minimum required version now. 1.6.0 Enhancements Support Distillery 2.x Backwards incompatible changes Distillery 1.x is not supported anymore 1.5.3 Fixes Truly fixes broken distillery compatibility by @TokiTori 1.5.2 Fixes Fix broken distillery compatibility by @TokiTori 1.5.1 Enhancements Warnings cleanup by @kanmo New autoversion option &quot;-time&quot; by @tejanium 1.4.6 Good news everyone! Distillery compatibility is restored! Enhancements Require at least distillery 1.0.0 Remove compile warnings Tests run now on all OSs Bug fixes Fix issue with ControlPersist (#105) Fix profile output dir (#254) Fix posix compatibility (#147) Backwards incompatible changes Exrm support removed . As discussed here: https://elixirforum.com/t/edeliver-plans-to-remove-exrm-support-any-objections/12416 1.4.5 Merge pull request #248 from dmarkow/distillery-fixes Update docs for distillery integration Use correct output_dir from distillery Ensure docs are built for both exrm/distillery plugins Merge pull request #199 from otaq/master Sleep 1 before check node running 1.4.4 Removed support for spaces in project path. It broke using multiple hosts. Update Readme 1.4.3 Propagate exit code for the synchronous migration Added post_extract_release_archive hook Added support for spaces in project path. Pass branch variable when building release 1.4.2 Support Elixir 1.3.4 in addition to 1.4 1.4.1 Compatibility with elixir 1.4 Compatibility with elixir versions 1.3.[0-3] Improved support for distillery as build tool 1.4.0 Marked :exrm as :optional dependency. This requires to add :exrm as dependency to the mix file of the project if exrm is used as build tool Allow to build releases using distillery Improve detection whether exrm or distillery is used as build tool 1.3.0 Support distillery as release tool Add pre/post hook which is executed when deployed release is (re)started. Improve default automatic relup modifications and their api docs Fix compile warnings when compiling with elixir version &gt;= 1.3.0 Fix problem with node command output 1.2.10 Install also rebar3 on the build host Compatibility with elixir / mix version 1.3.0 Keep only valid SemVer characters in branch name from auto-versioning Fix ssh forwarding in non-verbose mode 1.2.9 Fix detecting version of single release file Improve branch detection for auto-versioning Warn if --auto-version is used with --skip-mix-clean Avoid user interaction for mix local.rebar command 1.2.8 Add update command to build and deploy in a single step Allow to append mix env as metadata to version Exrm 1.0.5 compatibility for node commands Allow to link sys.config and vm.args for each mix env 1.2.7 Allow to use umbrella projects also for the upgrade or build upgrade task Use ssh agent forwarding on build host to allow to use private git repositories as dependencies 1.2.6 Restart whole vm with most recent release for the restart command or --start-deploy option (Re-)start node(s) synchronously and print start progress for --verbose option Fix upgrade command for production deploy environments Improved error output 1.2.5 Fix error on automatic phoenix upgrades by not suspending the ranch acceptors supervisor Fix passing ECTO_REPOSITORY env to ecto migration tasks Ecto 2.0 support: read ecto_repos from application env Fix skipping automatic relup modifications for upgrades Fix changing the version of an old release which is build for an upgrade Fix --mix-env option 1.2.4 Support migrations for ecto version &gt;= 2.0 1.2.3 Improve displaying of revisions contained in the running release. 1.2.2 Fix detecting branch name on build host for --autoversion=branch[-unless-master] option. 1.2.1 Fix syntax on migrate task with down operation 1.2.0 Add upgrade task to automatically upgrade all nodes Add auto-versioning to append metadata to release versions Add command help mix edeliver help &lt;command&gt; Add automatic relup modifications Experimental support for auto-upgrades of phoenix apps 1.1.6 Fix issue caused by CDPATH being set 1.1.5 Fix displaying all output for node commands 1.1.4 Fix selecting release when deploying and no version is given 1.1.3 Fix hex.pm release by adding missing mix.exs 1.1.2 Fix ssh warning if edeliver is used as mix task Allow user interaction when building in verbose mode Suppress printing app script version if app script was generated with recent exrm version Fix skipping git clean when SKIP_GIT_CLEAN env is set Show very verbose output of exrm release task if it fails Fix name of post hook which is executed after updating the deps 1.1.1 added command line option --mix-env=&lt;env&gt; automatic authorization of/on release store host allow to build different apps in one project when APP env is used use always explicit compilation for exrm compatibility 1.1.0 allow incremental builds to decrease build time support for executing ecto migrations support exrm versions from 0.16.0 to &gt; 1.0.0 allow to link sys.config and vm.args in release display command output when build command failed keeps build repository size constant return correct status code if mix command failed deploy release non-interactively if also upgrade exists install hex non-interactive 1.0.0 initial version with elixir support","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"edeliver Deployment for Elixir and Erlang edeliver is based on deliver and enables you to build and deploy Elixir and Erlang applications and perform hot-code upgrades. The erlang releases are built on a remote host that is similar to the production machines - or in a docker container. After being built, the release can then be deployed to one or more production machines. Once built, the release contains the full erts (erlang runtime system) , all dependencies (erlang or elixir applications) , the Elixir runtime, native port drivers, and your erlang/elixir application(s) in a standalone embedded node.","ref":"readme.html","title":"Usage","type":"extras"},{"doc":"Edeliver Elixir 1.9.* 1.13.* 1.8.* 1.10.* 1.7.* 1.9.* 1.6.* 1.8.*","ref":"readme.html#version-compatibility","title":"Usage - Version compatibility","type":"extras"},{"doc":"Issues #deployment on Slack Community Wiki — feel free to contribute!","ref":"readme.html#community","title":"Usage - Community","type":"extras"},{"doc":"Quick Start Installation Configuration Build Commands Deploy Commands Admin Commands Help Examples License","ref":"readme.html#contents","title":"Usage - Contents","type":"extras"},{"doc":"Assuming an Elixir project, you already have a build server and a staging server, and you've created a database on your staging server already (there is no ecto.create, we skip straight to migrations). Add edeliver and your build tool ( distillery ) to your project dependencies in mix.exs: def application, do: [ applications: [ ... # Add edeliver to the END of the list :edeliver ] ] defp deps do [ ... {:edeliver, &quot;&gt;= 1.9.0&quot;}, {:distillery, &quot;~&gt; 2.1&quot;, warn_missing: false}, ] end If this is a Phoenix project, upload your prod.secret.exs to your build server somewhere. Let's say it's at /home/builder/prod.secret.exs. In your project, create the file .deliver/config # .deliver/config APP=&quot;myapp&quot; BUILD_HOST=&quot;my-build-server.myapp.com&quot; BUILD_USER=&quot;builder&quot; BUILD_AT=&quot;/tmp/edeliver/myapp/builds&quot; STAGING_HOSTS=&quot;stage.myapp.com&quot; STAGING_USER=&quot;web&quot; DELIVER_TO=&quot;/home/web&quot; # For *Phoenix* projects, symlink prod.secret.exs to our tmp source pre_erlang_get_and_update_deps() { local _prod_secret_path=&quot;/home/builder/prod.secret.exs&quot; if [ &quot;$TARGET_MIX_ENV&quot; = &quot;prod&quot; ]; then __sync_remote &quot; ln -sfn &#39;$_prod_secret_path&#39; &#39;$BUILD_AT/config/prod.secret.exs&#39; &quot; fi } Add the release directory to your gitignore echo &quot;.deliver/releases/&quot; &gt;&gt; .gitignore Commit everything, compile the new dependencies: git add -A &amp;&amp; git commit -m &quot;Setting up edeliver&quot; mix do deps.get, compile Now you can release with edeliver! mix edeliver update mix edeliver start mix edeliver migrate","ref":"readme.html#quick-start","title":"Usage - Quick Start","type":"extras"},{"doc":"Because it is based on deliver , it uses only shell scripts and has no further dependencies except the Erlang/Elixir build system. It can be used with any one of these build systems: mix in conjunction with distillery for elixir/erlang releases (recommended) mix in conjunction with relx for elixir/erlang releases rebar3 for pure erlang releases or in conjunction with rebar_mix plugin to build also Elixir sources and dependencies rebar for legacy pure erlang releases Edeliver tries to autodetect which system to use: If a ./mix.exs and a rel/config.exs file exists, mix is used fetch the dependencies, compile the sources and distillery is used to generate the releases / upgrades. If a ./relx.config file exists in addition to a ./mix.exs file, mix is used fetch the dependencies, compile the sources and relx is used to generate the releases / upgrades. If a ./rebar.config file exists but no ./relx.config , rebar3 is used to fetch the dependencies, compile the sources and to build the release Otherwise rebar is used to fetch the dependencies, compile the sources and generate the releases / upgrades. It is recommended to migrate to rebar3 in that case. This can be overridden by the config variables BUILD_CMD=rebar3|rebar|mix , RELEASE_CMD=rebar3|rebar|mix|relx and USING_DISTILLERY=true|false in .deliver/config . Edeliver uses ssh and scp to build and deploy the releases. It is recommended that you use ssh and scp with key+passphrase only. You can use ssh-add if you don't want to enter your passphrase every time. It may be required to install and configure git on your build host. You may also have to clone the repository initially at the BUILD_AT path, although edeliver will try to take care of this for you. Erlang and Elixir must be installed and available on the BUILD_HOST . The default shell for the build user should be bash or zsh on your build host (usually already the default on most systems). The build host must be similar to the production/staging hosts. For example, if you want to deploy to a production system based on Linux, the release must also be built on a Linux system. The Erlang runtime (OTP) and the Elixir runtime are packaged with the release—you do not have to install Erlang or Elixir separately on your production/staging servers. Mix considerations If using mix , add edeliver and your build tool ( distillery as hex package to your mix.exs config: defp deps do [ {:edeliver, &quot;&gt;= 1.9.0&quot;}, {:distillery, &quot;~&gt; 2.1&quot;, warn_missing: false}, ] end Run mix do deps.get, deps.compile . Edeliver is then available as a mix task: mix edeliver . Some edeliver commands used for server administration require that edeliver be running on the server itself so that it can respond. These commands include version , migrate , show migrations , etc. To enable this, add edeliver as application to be started in mix.exs . It should be added last at the end of the list: def application, do: [ applications: [ # ... :edeliver, ], ] Rebar3 considerations When using rebar3 , edeliver can be added as rebar3 dependency . Just add it to your rebar.config (and ensure that a ./rebar3 binary/link is in your project directory): { deps , [ % ... { edeliver , { git , &quot;git://github.com/edeliver/edeliver.git&quot; , { tag , &quot;1.9.0-rc.1&quot; } } } ] } . And link the edeliver binary to the root of your project directory: wget https :// s3 . amazonaws . com / rebar3 / rebar3 &amp;&amp; chmod + x rebar3 . / rebar3 get - deps ln - s . / _build / default / lib / edeliver / bin / edeliver . / edeliver Then use the linked binary ./edeliver to build and deploy releases. The default rebar3 profile can be overridden by setting the REBAR_PROFILE environment variable in the edeliver config e.g. to prod . Rebar considerations When using rebar, edeliver can be added as rebar dependency. Just add it to your rebar.config (and ensure that a ./rebar binary/link is in your project directory): { deps , [ % ... { edeliver , &quot;1.9.0&quot; , { git , &quot;git://github.com/boldpoker/edeliver.git&quot; , { branch , master } } } ] } . And link the edeliver binary to the root of your project directory: . / rebar get - deps # when using rebar, or ... ln - s . / deps / edeliver / bin / edeliver . Then use the linked binary ./edeliver instead of the mix edeliver tasks from the examples.","ref":"readme.html#installation","title":"Usage - Installation","type":"extras"},{"doc":"Create a .deliver directory in your project folder and add the config file: #!/usr/bin/env bash APP=&quot;your-erlang-app&quot; # name of your release BUILD_HOST=&quot;build-system.acme.org&quot; # host where to build the release, or &quot;docker&quot; BUILD_USER=&quot;build&quot; # local user at build host BUILD_AT=&quot;/tmp/erlang/my-app/builds&quot; # build directory on build host STAGING_HOSTS=&quot;test1.acme.org test2.acme.org&quot; # staging / test hosts separated by space STAGING_USER=&quot;test&quot; # local user at staging hosts TEST_AT=&quot;/test/my-erlang-app&quot; # deploy directory on staging hosts. default is DELIVER_TO PRODUCTION_HOSTS=&quot;deploy1.acme.org deploy2.acme.org&quot; # deploy / production hosts separated by space PRODUCTION_USER=&quot;production&quot; # local user at deploy hosts DELIVER_TO=&quot;/opt/my-erlang-app&quot; # deploy directory on production hosts To use different configurations on different hosts, you can configure edeliver to link the vm.args and/or the sys.config files in the release package by setting the LINK_VM_ARGS=/path/to/vm.args and/or LINK_SYS_CONFIG=/path/to/sys.config variables in the edeliver config if you use mix and distillery to build the releases. Another strategy is to use runtime environment variable evaluation (available for distillery and relx ). For more information on this technique, see Plataformatec - Deploying Elixir with edeliver This strategy relies on exporting an environment variable in your deployment environment to signal that environment variable replacement should be performed, as well as exporting all of the environment variables your configuration relies on. For relx , export RELX_REPLACE_OS_VARS=true . For distillery , export REPLACE_OS_VARS=true . For example in ~/.profile export REPLACE_OS_VARS=true export MY_CUSTOM_DATABASE_PORT=5433","ref":"readme.html#configuration","title":"Usage - Configuration","type":"extras"},{"doc":"For build commands the following configuration variables must be set: APP : the name of your release which should be built BUILD_HOST : the host where to build the release, or &quot;docker&quot; to build in a docker container BUILD_USER : the local user at build host BUILD_AT : the directory on build host where to build the release. must exist. The built release is then copied to your local directory .deliver/releases and can then be delivered to your production servers by using one of the deploy commands . If compiling and generating the release build was successful, the release is copied from the remote build host to the release store . The default release store is the local .deliver directory but you can configure any destination with the RELEASE_STORE= environment variables, also remote ssh destinations (in your server network) like RELEASE_STORE=user@releases.acme.org:/releases/ , amazon s3 locations like s3://AWS_ACCESS_KEY_ID@AWS_SECRET_ACCESS_KEY:bucket or as a docker image like docker://edeliver/echo-server . The release is copied from the remote build host using the RELEASE_DIR= environment variable. If this is not set, the default directory is found by finding the subdirectory that contains the generated RELEASES file and has the $APP name in the path. e.g. if $APP=myApp and the RELEASES file is found at rel/myApp/myApp/releases/RELEASE the rel/myApp/myApp is copied to the release store. To build releases and upgrades faster , you might adjust the GIT_CLEAN_PATHS variable in your config file e.g. to something like =&quot;_build rel priv/generated&quot; which defaults to . . That value means, that everything from the last build is reset (beam files, release files, deps, generated assets etc.) before the next build is started to ensure that no conflicts with old (e.g. removed or renamed) files might arise. You can also use the command line option --skip-git-clean to skip this step completely and in addition with the --skip-mix-clean option for full incremental builds . Build Initial Release mix edeliver build release [ -- revision = &lt; git - revision &gt; | -- tag = &lt; git - tag &gt; ] [ -- branch = &lt; git - branch &gt; ] Builds an initial release that can be deployed to the production hosts. If you want to build a different tag or revision, use the --revision= or the --tag argument. If you want to build a different branch or the tag / revision is in a different branch, use the --branch= argument. Build in a docker container If BUILD_HOST is set to &quot;docker&quot; , edeliver builds the release in a docker container instead of building on a build host. It uses the docker image set as DOCKER_BUILD_IMAGE which defaults to elixir:1.13.3 with erlang 24, but can be overridden in your .deliver/config . When building in a docker container, the git repository to build is pushed to the local dir .docker-build which is then mounted into the container and edelivers build commands are executed as docker exec commands in the container. Build as a docker container If RELEASE_STORE is a (private) docker image in a docker registry like docker://edeliver/echo-server the built release will be embedded into a docker image based on DOCKER_RELEASE_BASE_IMAGE (which defaults to edeliver/release-base:1.0 ) and pushed with that image name from the RELEASE_STORE to your registry (if --push is used). It creates (and optionally pushes) three image tags: release version + latest , release version + git sha and release version + branch . The release can then be started on a host authenticated at the same docker registry like this: docker start -ti edeliver/echo-server:1.0-latest -p 8080:8080 echo-server/bin/echo-server console Build an upgrade package mix edeliver build upgrade -- from = &lt; git - tag - or - revision &gt; | -- with = &lt; release - version - from - store &gt; [ -- to = &lt; git - tag - or - revision &gt; ] [ -- branch = &lt; git - branch &gt; ] Builds an upgrade package that can be deployed to production hosts with running nodes without restarting them. To build an upgrade package you need the release or upgrade package (when using distillery ) of the running release. If it is available (in the release store), you can build the upgrade to the new version by passing the old version to the --with=&lt;old-version&gt; option. If not, you can build the old release and the live upgrade from it in a single step by using the --from=&lt;git-tag-or-revision&gt; option. If you don't want to build an upgrade to the current head of the given branch ( master is the default), you can use the --to=&lt;git-tag-or-revision&gt; option. If the upgrade package is built, you might want to modify the generated upgrade instructions ( relup ) as described in the next section or (more advanced) automatically patch the relup file by implementing your own Edeliver.Relup.Modification behaviour to automate this step. Edit upgrade instructions (relup) mix edeliver edit relup [ -- version = &lt; upgrade - version &gt; ] From the auto-generated appup instructions of all included and updated applications, a relup file is generated during the build upgrade command and included in the upgrade package. It contains the upgrade instructions for the new release version. If there are dependencies between modules or applications, it might be necessary to modify this file, e.g. changing the order of the applications or modules that are reloaded. If there are repeating steps to adjust the relup for your application, you can automate this step by implementing your own Edeliver.Relup.Modification behavior. Auto-Versioning edeliver provides a way to automatically increment the current version for the current build and/or to append metadata to the version (such as the current git sha). Having unique versions for each release is important especially if you build hot code upgrades. It also helps to determine exactly which version is running when using mix edeliver version . For more information check the --auto-version= option described e.g in mix edeliver help upgrade or in the wiki . Build Restrictions (rebar) To build upgrades, there must be only one release in the release directory ( rel ) of your project as configured in your rebar.config . E.g. if you want to build two different releases project-dir/rel/release_a and project-dir/rel/release_b you need two rebar.config files that refer only to either one of that release directories in the sub_dirs section. You can then pass the config file to use by setting the environment REBAR_CONFIG= at the command line. The reason for that is, that when the upgrade is build with rebar, rebar tries to find the old version in both release directories.","ref":"readme.html#build-commands","title":"Usage - Build Commands","type":"extras"},{"doc":"mix edeliver deploy release | upgrade [ [ to ] staging | production ] [ -- version = &lt; release - version &gt; ] [ Options ] Deploy commands deliver the builds that were created with a build command to your staging or production hosts. They can also perform a live code upgrade. Built releases or upgrades are available in your local directory .deliver/releases . To deploy releases the following configuration variables must be set: APP : the name of your release which should be built PRODUCTION_HOSTS : the production hosts to deploy to, separated by space PRODUCTION_USER : the local users at the production hosts DELIVER_TO : the directory at the production hosts to deploy the release at STAGING_HOSTS : the staging hosts to test the releases at, separated by space STAGING_USER : the local users at the staging hosts TEST_AT : the directory at the staging hosts. if not set, the DELIVER_TO is used as directory Deploying to staging can be used to test your releases and upgrades before deploying them to the production hosts. Staging is the default target if you don't pass the [to] production argument. If the RELEASE_STORE is a docker image, the deploy command pulls and starts the image with the given tag as version. See section Deploy Docker Releases below for details. Deploy an initial/clean release mix edeliver deploy Deploys an initial release at the production hosts. This requires that the build release command was executed before. If there are several releases in the release store, you will be asked which release to deploy or you can pass the version by the --version= argument variable. If the nodes on the remote deploy hosts are up, the running old release is not affected—the new release will be available only after starting or restarting the nodes on the deploy hosts. Deploy an upgrade mix edeliver upgrade Deploys an upgrade at the production hosts and upgrades the running nodes to the new version. This requires that the build upgrade command was executed before, and that there is already an initial release deployed to the production hosts, and that the node is running. Release archives in your release store that were created by the build release command cannot be used to deploy an upgrade . This command requires that your release start script was generate by a recent rebar version that supports the upgrade command in addition to the start|stop|ping|attach commands. Releases generated with mix and distillery always contain the upgrade command. If using rebar, make sure that the install_upgrade.escript file which was generated by rebar is included in your release. So ensure, that the following line is in your reltool.config : { overlay , [ ... { copy , &quot;files/install_upgrade.escript&quot; , &quot;bin/install_upgrade.escript&quot; } ] } . Deploy Docker Releases When embedding releases into docker containers, the deploy command pulls the docker image from the registry defined as RELEASE_STORE and extracts the boot script from /$APP/bin/start_container (can be configured in CONTAINER_START_SCRIPT ) to $DELIVER_TO/bin while replacing the string {{edeliver-version}} with the version which is deployed. The script should use that value to always start that tag of the image. The start script should handle the same commands as the extended start script from relx/rebar , at least the start , stop and version commands. It could start the container with e.g. like this VERSION=&quot;{{edeliver-version}}&quot; docker run --rm --detatch \\ --workdir &quot;/${APP}&quot; \\ --publish 127.0.0.1:8080:8080 \\ --env ERL_DIST_PORT=&quot;${ERL_DIST_PORT:-9999}&quot; \\ --env INET_DIST_USE_INTERFACE=&#39;{0,0,0,0}&#39; \\ --mount type=bind,source=$HOME/.erlang.cookie,target=/root/.erlang.cookie my-registry/my-image:$VERSION /$APP/bin/$APP console","ref":"readme.html#deploy-commands","title":"Usage - Deploy Commands","type":"extras"},{"doc":"edeliver has a set of commands to check up on your running nodes: mix edeliver ping production # shows which nodes are up and running mix edeliver version production # shows the release version running on the nodes mix edeliver show migrations on production # shows pending database migrations mix edeliver migrate production # run database migrations mix edeliver restart production # or start or stop","ref":"readme.html#admin-commands","title":"Usage - Admin Commands","type":"extras"},{"doc":"If something goes wrong, retry with the --verbose option. If you want to see everything, try the --debug option. For detailed information about the edeliver commands and their options, try mix edeliver help &lt;command&gt; . For advanced usage have a look also at the wiki . Definitely join the #deployment channel in the Elixir Slack community as well. Recommended Project Structure your - app / &lt;- project root dir + rebar &lt;- rebar binary + mix &lt;- optional mix binary when compiling with mix + relx &lt;- optional relx binary if rebar is not used + edeliver &lt;- edeliver binary linking to deps / deliver / bin / deliver + rebar . config &lt;- should have &quot;rel/your-app&quot; in the sub_dirs section + mix . exs &lt;- if present , mix is used for dependencies and compile + relx . config &lt;- if present , relx is used for releases + . deliver &lt;- default release store | + releases / * . tar . gz &lt;- the built releases / upgrade packages | + appup / OldVsn - NewVsn / * . apppup &lt;- generated appup files | + config &lt;- deliver configuration + src / &lt;- erlang source files | + * . erl | + your - app . app . src + lib / &lt;- elixir source files | + * . ex + priv / + deps / | + edeliver / + rel / + your - app / + files / | + your - app &lt;- binary to start | stop | upgrade your app | + nodetool &lt;- helper for your - app binary | + install - upgrade . escript &lt;- helper for the upgrade task of your - app binary | + sys . config &lt;- app configuration for the release build | + vm . args &lt;- erlang vm args for the node + reltool . config &lt;- should have the install_upgrade . escript in overlay section","ref":"readme.html#help","title":"Usage - Help","type":"extras"},{"doc":"Build a release and deploy it to your production hosts: mix edeliver build release --branch=feature mix edeliver deploy release to production mix edeliver start production Or execute the above steps with a single command: mix edeliver update production --branch=feature --start-deploy Build a live upgrade from v1.0 to v2.0 for a release and deploy it to production: # build upgrade from tag v1.0 to v2.0 mix edeliver build upgrade --from=v1.0 --to=v2.0 mix edeliver deploy upgrade to production # or if you have the old release in your release store, # you can build the upgrade with that old release instead of the old git revision/tag mix edeliver build upgrade --with=v1.0 --to=v2.0 mix edeliver deploy upgrade to production # run ecto migrations manually: mix edeliver migrate production # or automatically during upgrade when upgrade is built with --run-migrations The deployed upgrade will be available immediately, without restarting your application. If the generated upgrade instructions (relup) for the hot code upgrade are not sufficient, you can modify these files before installing the upgrade by using the edeliver edit relup command. To execute that steps by a single command and upgrade e.g. all production nodes automatically from their running version to the current version using hot code upgrade without restarting, you can use the upgrade command: mix edeliver upgrade production This performs the following steps automatically: Detect current version on all running nodes Validate that all nodes run the same version Build new upgrade from that version to the current version Auto-patch the relup file Deploy (hot code) upgrade while nodes are running Validate that all nodes run the upgraded version Deploy the release to not running nodes","ref":"readme.html#examples","title":"Usage - Examples","type":"extras"},{"doc":"(The MIT license) Copyright (c) Gerhard Lazu Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"readme.html#license","title":"Usage - LICENSE","type":"extras"},{"doc":"Using Auto-Versioning edeliver provides a way to automatically increment the current version for the current build and/or to append the git commit count and/or revision as version metadata . Using a different versions for each release is essential especially if you build hot code upgrades , but also makes sense to see which version is running, e.g. when using mix edeliver version [staging|production] . Notice: This feature cannot be used in conjunction with the --skip-mix-clean command line option or the SKIP_MIX_CLEAN=true config respectively*. Append git commit count and/or revision to the release version mix release.version show 1.0.0 mix edeliver build release --auto-version=commit-count # creates version 1.0.0+3027 mix edeliver build upgrade --auto-version=git-revision # creates version 1.0.0+82a5834 mix edeliver build upgrade --auto-version=commit-count+git-revision # creates version 1.0.0+3027-82a5834 mix edeliver build upgrade --auto-version=git-revision+commit-count # creates version 1.0.0+82a5834-3027 Append other metadata: git branch or build date mix release.version show 1.0.0 mix edeliver build release --auto-version=git-branch # creates version 1.0.0+master mix edeliver build release --auto-version=git-revision+git-branch-unless-master # creates version 1.0.0+82a5834 mix edeliver build upgrade --auto-version=build-date # creates version 1.0.0+20160414 mix edeliver build upgrade --auto-version=git-revision+build-date # creates version 1.0.0+82a5834-20160414 Append metadata to version permanently To append metadata permanently you can set the AUTO_VERSION configuration variable in your .deliver/config file. This can be overridden by the --auto-version= command line argument. # ./deliver/config AUTO_VERSION=commit-count+git-revision+branch-unless-master Available metadata which can be appended to the release version [git-]revision Appends sha1 git revision of current HEAD. [git-]branch Appends the current branch that is built. [git-]branch-unless-master Appends the current branch that is built but only unless it is the master branch. [build-]date Appends the build date as YYYYMMDD. [build-]time Appends the build time as HHMMSS. [git-]commit-count[-all[-branches] Appends the number of commits across all branches. Allows edeliver to detect which version is newer if it is appended as first metadata to the release version. [git-]commit-count-branch Appends the number of commits from the current branch. This makes more sense, if the branch name is also appended as metadata to avoid conflicts from different branches. Using commit count across all branches ( commit-count[-all[-branches] ) or using the build date ( [build-]date ) as first metadata to append, enables edeliver to consider that values when sorting versions. Using [git-]revision or commit count for the current branch in conjunction with the branch name ( commit-count-branch+branch ) enables you to uniquely identify the built/deployed version . If the revision is used, edeliver can display the commit message for that version (and the 5 previous commit messages) if edeliver version [staging|production] is used. To achieve both (sorting and identifying versions) and to see whether a feature branch is built/deployed, the following permanent auto-versioning option is recommended: AUTO_VERSION=commit-count+git-revision+branch-unless-master . For more information also try mix edeliver help upgrade , mix edeliver help release or mix help release.version . Example Output for edeliver version task if git-revision is used for auto-versioning: $ mix edeliver version production EDELIVER YOUR_APP WITH VERSION COMMAND -----&gt; getting release versions from production servers production node: 0 user : production host : host-01.domain.net path : /your/deploy/path response: 1.2.3+4915-e834c67 branch : master revision: e834c67 date : 2016-04-19 17:10:13 (git commit) commits : Use autoversion for edeliver Update release version to 1.2.3 Revert something Add something ... production node: 1 user : production host : host-12.domain.net path : /your/deploy/path response: 1.2.3+4931-4805b65 branch : feature revision: 4805b65 date : 2016-04-21 16:41:01 (git commit) commits : Add another feature Add new feature Use autoversion for edeliver Update release version to 1.2.3 Revert something Add something ... VERSION DONE! Then number of commits can be adjusted by the VERSION_INFO_LAST_COMMITS env / config. Increment / Set Version for the current release / upgrade mix release.version show 1.2.3 mix edeliver build release --increment-version=patch # creates version 1.2.4 mix edeliver build release --increment-version=minor # creates version 1.3.0 mix edeliver build release --increment-version=minor # creates version 2.0.0 mix edeliver build release --set-version=1.3.0-beta.1 # creates version 1.3.0-beta.1 --increment-version= and --set-version= can be used in conjunction with the --auto-version= option. The AUTO_VERSION default is also used unless the --auto-version= overrides it. Use the Auto-Versioning / Increment-Version mix task locally You can also use the auto versioning mix task provided by edeliver locally on your development machine, e.g. when testing your release / upgrade. The argument names to append metadata differ slightly and contain an (optional) append- prefix. If version modifiers are combined, they can be separated by a space (or by the + character as for the edeliver option). It is required to clean the build output before* and to run the release.version and release mix tasks together using the mix do task while running the release.version task before the release task. mix release.version show 1.2.3 mix do clean, release.version increase major revision branch --dry-run Would update version from 1.2.3 to 2.0.0+82a5834-test # prints only the info above. You can always omit the &#39;append-git-&#39; part. mix do clean, release.version append-git-revision, release # creates version 1.2.3+82a5834 mix do clean, release.version append-commit-count append-git-revision append-git-branch, release # creates version 1.2.3+3027-82a5834-master mix do clean, release.version increase major, release AUTO_VERSION=&quot;append-git-revision&quot; mix do clean, release.version set 1.3.0-beta.1, release # creates version 1.3.0-beta.1+82a5834 (*) The build files must be removed to ensure that the your_app.app file will be (re-)generated with the new version.","ref":"auto-versioning.html","title":"Auto-Versioning","type":"extras"},{"doc":"Relup-Patching edeliver provides a mechanism to automatically patch / modify the generated relup instrunctions for a release upgrade. This is often required depending on the application to upgrade and depending on the changes made on the code. To automatically modify the relup file the Edeliver.Relup.Modification behaviour must be implemented. It can call several implementations of the Edeliver.Relup.Instruction behaviour in its modify_relup/2 callback which represent single modifications. Default Relup-Patching used by edeliver At the moment there exist two experimental default modifications, one general for all applications ( Edeliver.Relup.DefaultModification ) and one for phoenix applications ( Edeliver.Relup.PhoenixModification ). To disable the automatic relup modifications you can use the --skip-relup-mod option when building the upgrade. Instructions provided by edeliver If you want or need to implement your own Edeliver.Relup.Modification , the following instructions provided by edeliver can be used: Edeliver.Relup.Instructions.CheckProcessesRunningOldCode : aborts the upgrade if processes uses old code from previous upgrades Edeliver.Relup.Instructions.CheckRanchAcceptors : checks whether ranch acceptors can be found or aborts the upgrade Edeliver.Relup.Instructions.CheckRanchConnections : checks whether ranch connections can be found or aborts the upgrade Edeliver.Relup.Instructions.CodeChangeOnAppProcesses : runs code_change on suspended processes Edeliver.Relup.Instructions.FinishRunningRequests : notifies running phoenix requests that an upgrade starts Edeliver.Relup.Instructions.Info : prints info to the log on the nodes and the edeliver upgrade output Edeliver.Relup.Instructions.ReloadModules : reloads changed modules Edeliver.Relup.Instructions.RerunFailedRequests : reruns phoenix requests that failed during the upgrade Edeliver.Relup.Instructions.ResumeAppProcesses : resumes suspended processes Edeliver.Relup.Instructions.ResumeChannels : resumes suspended phoenix channels Edeliver.Relup.Instructions.ResumeRanchAcceptors : resumes suspended ranch acceptors Edeliver.Relup.Instructions.Sleep : sleeps some time. useful for upgrade testing Edeliver.Relup.Instructions.SoftPurge : replaces :brutal_purge with :soft_purge in code-loading instructions Edeliver.Relup.Instructions.StartSection : prints info to the log on the nodes and the edeliver upgrade output that a new upgrade section starts Edeliver.Relup.Instructions.SuspendAppProcesses : suspends processes using changed code Edeliver.Relup.Instructions.SuspendChannels : suspends phoenix channels Edeliver.Relup.Instructions.SuspendRanchAcceptors : suspends ranch acceptors Custom Instructions If you want to use a custom instruction in your custom Edeliver.Relup.Modification you must implement the Edeliver.Relup.Instruction behaviour and implement the modify_relup/2 callback. This allows e.g. to reorder, to add or to remove relup instructions . If you just want to execute custom code during the upgrade you might want to use the more extended Edeliver.Relup.RunnableInstruction behaviour and implement the run/1 function. If you think the custom instruction might be useful also for other applications, feel free to submit a pull request. Integration with Distillery In order for your modifications to be applied, you have to configure Distillery to use edeliver's Releases.Plugin.ModifyRelup plugin. You can configure this in the rel/config.exs file like this: environment :prod do .. plugin Releases.Plugin.ModifyRelup end Example This example shows a custom (runnable) instruction which would execute pending ecto migrations during the upgrade. This custom instruction is then used in a custom relup modification which adds this instruction at the end of the generated relup instructions including some info output ( Edeliver.Relup.Instructions.StartSection ). defmodule MyApp.Relup.MigrationInstruction do @moduledoc &quot;&quot;&quot; Executes ecto migrations during the upgrade. Can be used in any relup modification. &quot;&quot;&quot; use Edeliver.Relup.RunnableInstruction @doc &quot;insert after all other instructions&quot; def insert_where , do : &amp; append / 2 @doc &quot;pass application name and version to the `run/1` function when executing the relup&quot; def arguments ( _instructions = % Instructions { up_version : up_version } , _config = %{ name : name } ) do { name , up_version } end @doc &quot;runs during upgrade&quot; def run ( { otp_application_name , up_version } ) do info &quot;Running pending migrations...&quot; { :ok , [ ecto_repository_module ] } = Application . fetch_env ( otp_application_name , :ecto_repos ) # requires ecto 2.0 Ecto.Migrator . run ( ecto_repository_module , migrations_dir ( otp_application_name , up_version ) , :up , [ all : true ] ) end defp migrations_dir ( application_name , application_version ) do # use priv dir from the new version lib_dir = :code . priv_dir ( application_name ) |&gt; to_string |&gt; Path . dirname |&gt; Path . dirname application_with_version = &quot; \#{ Atom . to_string ( application_name ) } - \#{ application_version } &quot; Path . join ( [ lib_dir , application_with_version , &quot;priv&quot; , &quot;repo&quot; , &quot;migrations&quot; ] ) end end defmodule MyApp.Relup.MigrationModification @moduledoc &quot;&quot;&quot; Runs pending migrations during the upgrade in addition to the generated code-chaning instructions. &quot;&quot;&quot; use Edeliver.Relup.Modification def modify_relup ( instructions = % Instructions { } , config = %{ } ) do instructions # check whether upgrade is possible |&gt; Edeliver.Relup.Instructions.StartSection . modify_relup ( config , :check ) |&gt; Edeliver.Relup.Instructions.CheckProcessesRunningOldCode . modify_relup ( config ) # run the upgrade |&gt; Edeliver.Relup.Instructions.SoftPurge . modify_relup ( config ) |&gt; Edeliver.Relup.Instructions.SuspendAppProcesses . modify_relup ( config ) |&gt; Edeliver.Relup.Instructions.ReloadModules . modify_relup ( config ) |&gt; Edeliver.Relup.Instructions.CodeChangeOnAppProcesses . modify_relup ( config ) # run the custom instruction |&gt; MyApp.Relup.MigrationInstruction . modify_relup ( config ) # &lt;-------------------- |&gt; Edeliver.Relup.Instructions.ResumeAppProcesses . modify_relup ( config ) |&gt; Edeliver.Relup.Instructions.StartSection . modify_relup ( config , :finished ) end @doc &quot;usable if ecto is a dependency&quot; def usable? ( _config = %{ } ) do deps = Mix.Project . config [ :deps ] List . keymember? ( deps , :ecto , 0 ) end @doc &quot;returns higher priority as the edeliver defaults&quot; def priority , do : priority_user end","ref":"relup-patching.html","title":"Relup-Patching","type":"extras"}]